/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 2

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         PARSER_STYPE
#define YYLTYPE         PARSER_LTYPE
/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* Copy the first part of user declarations.  */
#line 1 "tools/widl/parser.y" /* yacc.c:339  */

/*
 * IDL Compiler
 *
 * Copyright 2002 Ove Kaaven
 * Copyright 2006-2008 Robert Shearman
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include "widl.h"
#include "utils.h"
#include "parser.h"
#include "header.h"
#include "typelib.h"
#include "typegen.h"
#include "expr.h"
#include "typetree.h"

struct _import_t
{
  char *name;
  int import_performed;
};

static str_list_t *append_str(str_list_t *list, char *str);
static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right,
        enum storage_class stgclass, enum type_qualifier qual, enum function_specifier func_specifier);
static expr_list_t *append_expr(expr_list_t *list, expr_t *expr);
static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_t *decl, int top);
static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls);
static var_list_t *append_var_list(var_list_t *list, var_list_t *vars);
static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *p);
static declarator_t *make_declarator(var_t *var);
static type_t *make_safearray(type_t *type);
static typelib_t *make_library(const char *name, const attr_list_t *attrs);
static void append_array(declarator_t *decl, expr_t *expr);
static void append_chain_type(declarator_t *decl, type_t *type, enum type_qualifier qual);
static void append_chain_callconv( struct location where, type_t *chain, char *callconv );
static warning_list_t *append_warning(warning_list_t *, int);

static type_t *reg_typedefs( struct location where, decl_spec_t *decl_spec, var_list_t *names, attr_list_t *attrs );
static type_t *find_type_or_error(struct namespace *parent, const char *name);
static struct namespace *find_namespace_or_error(struct namespace *namespace, const char *name);

static var_t *reg_const(var_t *var);

static void push_namespaces(str_list_t *names);
static void pop_namespaces(str_list_t *names);
static void push_parameters_namespace(const char *name);
static void pop_parameters_namespace(const char *name);

static statement_list_t *append_parameterized_type_stmts(statement_list_t *stmts);
static void check_statements(const statement_list_t *stmts, int is_inside_library);
static void check_all_user_types(const statement_list_t *stmts);
static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func);

static void check_async_uuid(type_t *iface);

static statement_t *make_statement(enum statement_type type);
static statement_t *make_statement_type_decl(type_t *type);
static statement_t *make_statement_reference(type_t *type);
static statement_t *make_statement_declaration(var_t *var);
static statement_t *make_statement_library(typelib_t *typelib);
static statement_t *make_statement_pragma(const char *str);
static statement_t *make_statement_cppquote(const char *str);
static statement_t *make_statement_importlib(const char *str);
static statement_t *make_statement_module(type_t *type);
static statement_t *make_statement_typedef(var_list_t *names, int declonly);
static statement_t *make_statement_import(const char *str);
static statement_t *make_statement_parameterized_type(type_t *type, typeref_list_t *params);
static statement_t *make_statement_delegate(type_t *ret, var_list_t *args);
static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt);
static statement_list_t *append_statements(statement_list_t *, statement_list_t *);

static struct namespace global_namespace = {
    NULL, NULL, LIST_INIT(global_namespace.entry), LIST_INIT(global_namespace.children)
};

static struct namespace *current_namespace = &global_namespace;
static struct namespace *parameters_namespace = NULL;
static statement_list_t *parameterized_type_stmts = NULL;

static typelib_t *current_typelib;


#line 182 "tools/widl/parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Debug traces.  */
#ifndef PARSER_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define PARSER_DEBUG 1
#  else
#   define PARSER_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define PARSER_DEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined PARSER_DEBUG */
#if PARSER_DEBUG
extern int parser_debug;
#endif
/* "%code requires" blocks.  */
#line 110 "tools/widl/parser.y" /* yacc.c:355  */


#define PARSER_LTYPE struct location


#line 223 "tools/widl/parser.tab.c" /* yacc.c:355  */

/* Token type.  */
#ifndef PARSER_TOKENTYPE
# define PARSER_TOKENTYPE
  enum parser_tokentype
  {
    aIDENTIFIER = 258,
    aPRAGMA = 259,
    aKNOWNTYPE = 260,
    aNUM = 261,
    aHEXNUM = 262,
    aDOUBLE = 263,
    aSTRING = 264,
    aWSTRING = 265,
    aSQSTRING = 266,
    tCDECL = 267,
    tFASTCALL = 268,
    tPASCAL = 269,
    tSTDCALL = 270,
    aUUID = 271,
    aEOF = 272,
    aACF = 273,
    SHL = 274,
    SHR = 275,
    MEMBERPTR = 276,
    EQUALITY = 277,
    INEQUALITY = 278,
    GREATEREQUAL = 279,
    LESSEQUAL = 280,
    LOGICALOR = 281,
    LOGICALAND = 282,
    ELLIPSIS = 283,
    tACTIVATABLE = 284,
    tAGGREGATABLE = 285,
    tAGILE = 286,
    tALLNODES = 287,
    tALLOCATE = 288,
    tANNOTATION = 289,
    tAPICONTRACT = 290,
    tAPPOBJECT = 291,
    tASYNC = 292,
    tASYNCUUID = 293,
    tAUTOHANDLE = 294,
    tBINDABLE = 295,
    tBOOLEAN = 296,
    tBROADCAST = 297,
    tBYTE = 298,
    tBYTECOUNT = 299,
    tCALLAS = 300,
    tCALLBACK = 301,
    tCASE = 302,
    tCHAR = 303,
    tCOCLASS = 304,
    tCODE = 305,
    tCOMMSTATUS = 306,
    tCOMPOSABLE = 307,
    tCONST = 308,
    tCONTEXTHANDLE = 309,
    tCONTEXTHANDLENOSERIALIZE = 310,
    tCONTEXTHANDLESERIALIZE = 311,
    tCONTRACT = 312,
    tCONTRACTVERSION = 313,
    tCONTROL = 314,
    tCPPQUOTE = 315,
    tCUSTOM = 316,
    tDECLARE = 317,
    tDECODE = 318,
    tDEFAULT = 319,
    tDEFAULTBIND = 320,
    tDELEGATE = 321,
    tDEFAULT_OVERLOAD = 322,
    tDEFAULTCOLLELEM = 323,
    tDEFAULTVALUE = 324,
    tDEFAULTVTABLE = 325,
    tDEPRECATED = 326,
    tDISABLECONSISTENCYCHECK = 327,
    tDISPLAYBIND = 328,
    tDISPINTERFACE = 329,
    tDLLNAME = 330,
    tDONTFREE = 331,
    tDOUBLE = 332,
    tDUAL = 333,
    tENABLEALLOCATE = 334,
    tENCODE = 335,
    tENDPOINT = 336,
    tENTRY = 337,
    tENUM = 338,
    tERRORSTATUST = 339,
    tEVENTADD = 340,
    tEVENTREMOVE = 341,
    tEXCLUSIVETO = 342,
    tEXPLICITHANDLE = 343,
    tEXTERN = 344,
    tFALSE = 345,
    tFAULTSTATUS = 346,
    tFLAGS = 347,
    tFLOAT = 348,
    tFORCEALLOCATE = 349,
    tHANDLE = 350,
    tHANDLET = 351,
    tHELPCONTEXT = 352,
    tHELPFILE = 353,
    tHELPSTRING = 354,
    tHELPSTRINGCONTEXT = 355,
    tHELPSTRINGDLL = 356,
    tHIDDEN = 357,
    tHYPER = 358,
    tID = 359,
    tIDEMPOTENT = 360,
    tIGNORE = 361,
    tIIDIS = 362,
    tIMMEDIATEBIND = 363,
    tIMPLICITHANDLE = 364,
    tIMPORT = 365,
    tIMPORTLIB = 366,
    tIN = 367,
    tIN_LINE = 368,
    tINLINE = 369,
    tINPUTSYNC = 370,
    tINT = 371,
    tINT32 = 372,
    tINT3264 = 373,
    tINT64 = 374,
    tINTERFACE = 375,
    tLCID = 376,
    tLENGTHIS = 377,
    tLIBRARY = 378,
    tLICENSED = 379,
    tLOCAL = 380,
    tLONG = 381,
    tMARSHALINGBEHAVIOR = 382,
    tMAYBE = 383,
    tMESSAGE = 384,
    tMETHODS = 385,
    tMODULE = 386,
    tMTA = 387,
    tNAMESPACE = 388,
    tNOCODE = 389,
    tNONBROWSABLE = 390,
    tNONCREATABLE = 391,
    tNONE = 392,
    tNONEXTENSIBLE = 393,
    tNOTIFY = 394,
    tNOTIFYFLAG = 395,
    tNULL = 396,
    tOBJECT = 397,
    tODL = 398,
    tOLEAUTOMATION = 399,
    tOPTIMIZE = 400,
    tOPTIONAL = 401,
    tOUT = 402,
    tOVERLOAD = 403,
    tPARTIALIGNORE = 404,
    tPOINTERDEFAULT = 405,
    tPRAGMA_WARNING = 406,
    tPROGID = 407,
    tPROPERTIES = 408,
    tPROPGET = 409,
    tPROPPUT = 410,
    tPROPPUTREF = 411,
    tPROTECTED = 412,
    tPROXY = 413,
    tPTR = 414,
    tPUBLIC = 415,
    tRANGE = 416,
    tREADONLY = 417,
    tREF = 418,
    tREGISTER = 419,
    tREPRESENTAS = 420,
    tREQUESTEDIT = 421,
    tREQUIRES = 422,
    tRESTRICTED = 423,
    tRETVAL = 424,
    tRUNTIMECLASS = 425,
    tSAFEARRAY = 426,
    tSHORT = 427,
    tSIGNED = 428,
    tSINGLENODE = 429,
    tSIZEIS = 430,
    tSIZEOF = 431,
    tSMALL = 432,
    tSOURCE = 433,
    tSTANDARD = 434,
    tSTATIC = 435,
    tSTRICTCONTEXTHANDLE = 436,
    tSTRING = 437,
    tSTRUCT = 438,
    tSWITCH = 439,
    tSWITCHIS = 440,
    tSWITCHTYPE = 441,
    tTHREADING = 442,
    tTRANSMITAS = 443,
    tTRUE = 444,
    tTYPEDEF = 445,
    tUIDEFAULT = 446,
    tUNION = 447,
    tUNIQUE = 448,
    tUNSIGNED = 449,
    tUSESGETLASTERROR = 450,
    tUSERMARSHAL = 451,
    tUUID = 452,
    tV1ENUM = 453,
    tVARARG = 454,
    tVERSION = 455,
    tVIPROGID = 456,
    tVOID = 457,
    tWCHAR = 458,
    tWIREMARSHAL = 459,
    tAPARTMENT = 460,
    tNEUTRAL = 461,
    tSINGLE = 462,
    tFREE = 463,
    tBOTH = 464,
    CAST = 465,
    PPTR = 466,
    POS = 467,
    NEG = 468,
    ADDRESSOF = 469
  };
#endif

/* Value type.  */
#if ! defined PARSER_STYPE && ! defined PARSER_STYPE_IS_DECLARED

union PARSER_STYPE
{
#line 134 "tools/widl/parser.y" /* yacc.c:355  */

	attr_t *attr;
	attr_list_t *attr_list;
	str_list_t *str_list;
	expr_t *expr;
	expr_list_t *expr_list;
	type_t *type;
	var_t *var;
	var_list_t *var_list;
	declarator_t *declarator;
	declarator_list_t *declarator_list;
	statement_t *statement;
	statement_list_t *stmt_list;
	warning_t *warning;
	warning_list_t *warning_list;
	typeref_t *typeref;
	typeref_list_t *typeref_list;
	char *str;
	struct uuid *uuid;
	unsigned int num;
	double dbl;
	typelib_t *typelib;
	struct _import_t *import;
	struct _decl_spec_t *declspec;
	enum storage_class stgclass;
	enum type_qualifier type_qualifier;
	enum function_specifier function_specifier;
	struct namespace *namespace;

#line 480 "tools/widl/parser.tab.c" /* yacc.c:355  */
};

typedef union PARSER_STYPE PARSER_STYPE;
# define PARSER_STYPE_IS_TRIVIAL 1
# define PARSER_STYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined PARSER_LTYPE && ! defined PARSER_LTYPE_IS_DECLARED
typedef struct PARSER_LTYPE PARSER_LTYPE;
struct PARSER_LTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define PARSER_LTYPE_IS_DECLARED 1
# define PARSER_LTYPE_IS_TRIVIAL 1
#endif



int parser_parse (void);
/* "%code provides" blocks.  */
#line 117 "tools/widl/parser.y" /* yacc.c:355  */


int parser_lex( PARSER_STYPE *yylval, PARSER_LTYPE *yylloc );
void push_import( const char *fname, PARSER_LTYPE *yylloc );
void pop_import( PARSER_LTYPE *yylloc );

# define YYLLOC_DEFAULT( cur, rhs, n ) \
        do { if (n) init_location( &(cur), &YYRHSLOC( rhs, 1 ), &YYRHSLOC( rhs, n ) ); \
             else init_location( &(cur), &YYRHSLOC( rhs, 0 ), NULL ); } while(0)


#line 518 "tools/widl/parser.tab.c" /* yacc.c:355  */



/* Copy the second part of user declarations.  */

#line 524 "tools/widl/parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined PARSER_LTYPE_IS_TRIVIAL && PARSER_LTYPE_IS_TRIVIAL \
             && defined PARSER_STYPE_IS_TRIVIAL && PARSER_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3781

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  239
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  147
/* YYNRULES -- Number of rules.  */
#define YYNRULES  500
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  925

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   469

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   223,     2,     2,     2,   222,   215,     2,
     236,   237,   220,   219,   210,   218,   230,   221,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   212,   233,
     216,   238,   217,   211,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   231,     2,   232,   214,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   234,   213,   235,   224,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   225,   226,   227,   228,   229
};

#if PARSER_DEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   369,   369,   385,   386,   390,   391,   397,   401,   402,
     407,   411,   412,   412,   414,   415,   416,   417,   418,   421,
     424,   425,   427,   428,   430,   431,   432,   433,   437,   438,
     439,   440,   440,   442,   443,   444,   445,   448,   449,   451,
     452,   454,   455,   456,   457,   458,   462,   463,   467,   468,
     472,   473,   474,   475,   476,   477,   478,   481,   489,   497,
     498,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     513,   516,   518,   521,   525,   527,   531,   536,   537,   540,
     541,   544,   545,   549,   554,   561,   565,   566,   570,   571,
     575,   578,   579,   580,   583,   584,   588,   589,   590,   594,
     595,   599,   607,   614,   618,   622,   623,   627,   635,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   769,   770,   771,   772,   776,   777,
     780,   784,   791,   792,   793,   796,   800,   812,   817,   821,
     826,   829,   830,   834,   835,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   877,   879,   880,   883,   884,   887,   893,
     900,   901,   904,   909,   916,   917,   921,   922,   926,   927,
     930,   934,   940,   948,   952,   958,   959,   963,   964,   967,
     968,   971,   974,   975,   976,   977,   978,   979,   980,   981,
     982,   983,   984,   988,   989,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1004,  1005,  1009,  1010,  1013,  1018,
    1019,  1020,  1021,  1022,  1026,  1027,  1031,  1034,  1038,  1041,
    1046,  1049,  1053,  1054,  1058,  1059,  1063,  1064,  1067,  1070,
    1073,  1074,  1077,  1078,  1082,  1084,  1089,  1090,  1091,  1094,
    1098,  1099,  1103,  1104,  1104,  1104,  1108,  1113,  1114,  1112,
    1121,  1122,  1123,  1124,  1128,  1129,  1132,  1132,  1145,  1149,
    1150,  1151,  1155,  1158,  1161,  1166,  1167,  1168,  1172,  1176,
    1180,  1181,  1184,  1185,  1189,  1191,  1196,  1197,  1201,  1202,
    1203,  1207,  1209,  1210,  1214,  1215,  1216,  1217,  1222,  1224,
    1225,  1230,  1232,  1237,  1238,  1243,  1244,  1245,  1246,  1250,
    1258,  1260,  1261,  1266,  1268,  1273,  1274,  1281,  1282,  1283,
    1284,  1285,  1289,  1296,  1297,  1301,  1302,  1305,  1312,  1313,
    1318,  1319,  1323,  1324,  1325,  1326,  1327,  1328,  1332,  1333,
    1334,  1337,  1341,  1342,  1343,  1344,  1345,  1346,  1347,  1348,
    1349,  1350,  1354,  1355,  1356,  1359,  1366,  1368,  1374,  1375,
    1376,  1380,  1381,  1385,  1386,  1390,  1397,  1406,  1407,  1411,
    1412,  1416,  1418,  1419,  1420,  1424,  1425,  1430,  1431,  1432,
    1433
};
#endif

#if PARSER_DEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "aIDENTIFIER", "aPRAGMA", "aKNOWNTYPE",
  "aNUM", "aHEXNUM", "aDOUBLE", "aSTRING", "aWSTRING", "aSQSTRING",
  "tCDECL", "tFASTCALL", "tPASCAL", "tSTDCALL", "aUUID", "aEOF", "aACF",
  "SHL", "SHR", "MEMBERPTR", "EQUALITY", "INEQUALITY", "GREATEREQUAL",
  "LESSEQUAL", "LOGICALOR", "LOGICALAND", "ELLIPSIS", "tACTIVATABLE",
  "tAGGREGATABLE", "tAGILE", "tALLNODES", "tALLOCATE", "tANNOTATION",
  "tAPICONTRACT", "tAPPOBJECT", "tASYNC", "tASYNCUUID", "tAUTOHANDLE",
  "tBINDABLE", "tBOOLEAN", "tBROADCAST", "tBYTE", "tBYTECOUNT", "tCALLAS",
  "tCALLBACK", "tCASE", "tCHAR", "tCOCLASS", "tCODE", "tCOMMSTATUS",
  "tCOMPOSABLE", "tCONST", "tCONTEXTHANDLE", "tCONTEXTHANDLENOSERIALIZE",
  "tCONTEXTHANDLESERIALIZE", "tCONTRACT", "tCONTRACTVERSION", "tCONTROL",
  "tCPPQUOTE", "tCUSTOM", "tDECLARE", "tDECODE", "tDEFAULT",
  "tDEFAULTBIND", "tDELEGATE", "tDEFAULT_OVERLOAD", "tDEFAULTCOLLELEM",
  "tDEFAULTVALUE", "tDEFAULTVTABLE", "tDEPRECATED",
  "tDISABLECONSISTENCYCHECK", "tDISPLAYBIND", "tDISPINTERFACE", "tDLLNAME",
  "tDONTFREE", "tDOUBLE", "tDUAL", "tENABLEALLOCATE", "tENCODE",
  "tENDPOINT", "tENTRY", "tENUM", "tERRORSTATUST", "tEVENTADD",
  "tEVENTREMOVE", "tEXCLUSIVETO", "tEXPLICITHANDLE", "tEXTERN", "tFALSE",
  "tFAULTSTATUS", "tFLAGS", "tFLOAT", "tFORCEALLOCATE", "tHANDLE",
  "tHANDLET", "tHELPCONTEXT", "tHELPFILE", "tHELPSTRING",
  "tHELPSTRINGCONTEXT", "tHELPSTRINGDLL", "tHIDDEN", "tHYPER", "tID",
  "tIDEMPOTENT", "tIGNORE", "tIIDIS", "tIMMEDIATEBIND", "tIMPLICITHANDLE",
  "tIMPORT", "tIMPORTLIB", "tIN", "tIN_LINE", "tINLINE", "tINPUTSYNC",
  "tINT", "tINT32", "tINT3264", "tINT64", "tINTERFACE", "tLCID",
  "tLENGTHIS", "tLIBRARY", "tLICENSED", "tLOCAL", "tLONG",
  "tMARSHALINGBEHAVIOR", "tMAYBE", "tMESSAGE", "tMETHODS", "tMODULE",
  "tMTA", "tNAMESPACE", "tNOCODE", "tNONBROWSABLE", "tNONCREATABLE",
  "tNONE", "tNONEXTENSIBLE", "tNOTIFY", "tNOTIFYFLAG", "tNULL", "tOBJECT",
  "tODL", "tOLEAUTOMATION", "tOPTIMIZE", "tOPTIONAL", "tOUT", "tOVERLOAD",
  "tPARTIALIGNORE", "tPOINTERDEFAULT", "tPRAGMA_WARNING", "tPROGID",
  "tPROPERTIES", "tPROPGET", "tPROPPUT", "tPROPPUTREF", "tPROTECTED",
  "tPROXY", "tPTR", "tPUBLIC", "tRANGE", "tREADONLY", "tREF", "tREGISTER",
  "tREPRESENTAS", "tREQUESTEDIT", "tREQUIRES", "tRESTRICTED", "tRETVAL",
  "tRUNTIMECLASS", "tSAFEARRAY", "tSHORT", "tSIGNED", "tSINGLENODE",
  "tSIZEIS", "tSIZEOF", "tSMALL", "tSOURCE", "tSTANDARD", "tSTATIC",
  "tSTRICTCONTEXTHANDLE", "tSTRING", "tSTRUCT", "tSWITCH", "tSWITCHIS",
  "tSWITCHTYPE", "tTHREADING", "tTRANSMITAS", "tTRUE", "tTYPEDEF",
  "tUIDEFAULT", "tUNION", "tUNIQUE", "tUNSIGNED", "tUSESGETLASTERROR",
  "tUSERMARSHAL", "tUUID", "tV1ENUM", "tVARARG", "tVERSION", "tVIPROGID",
  "tVOID", "tWCHAR", "tWIREMARSHAL", "tAPARTMENT", "tNEUTRAL", "tSINGLE",
  "tFREE", "tBOTH", "','", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'",
  "'-'", "'+'", "'*'", "'/'", "'%'", "'!'", "'~'", "CAST", "PPTR", "POS",
  "NEG", "ADDRESSOF", "'.'", "'['", "']'", "';'", "'{'", "'}'", "'('",
  "')'", "'='", "$accept", "input", "m_acf", "decl_statements",
  "decl_block", "imp_decl_statements", "imp_decl_block", "gbl_statements",
  "$@1", "imp_statements", "$@2", "int_statements", "semicolon_opt",
  "statement", "pragma_warning", "warnings", "typedecl", "cppquote",
  "import_start", "import", "importlib", "libraryhdr", "library_start",
  "librarydef", "m_args", "arg_list", "args", "arg", "array",
  "m_attributes", "attributes", "attrib_list", "str_list",
  "marshaling_behavior", "contract_ver", "contract_req", "static_attr",
  "activatable_attr", "access_attr", "composable_attr", "deprecated_attr",
  "attribute", "callconv", "cases", "case", "enums", "enum_list",
  "enum_member", "enum", "enumdef", "m_exprs", "m_expr", "expr",
  "expr_list_int_const", "expr_int_const", "expr_const", "fields", "field",
  "ne_union_field", "ne_union_fields", "union_field", "s_field", "funcdef",
  "declaration", "m_ident", "m_typename", "typename", "ident", "base_type",
  "m_int", "int_std", "namespace_pfx", "qualified_type",
  "parameterized_type", "parameterized_type_arg",
  "parameterized_type_args", "coclass", "coclassdef", "runtimeclass",
  "runtimeclass_def", "apicontract", "apicontract_def", "namespacedef",
  "class_interfaces", "class_interface", "dispinterface", "dispattributes",
  "dispint_props", "dispint_meths", "dispinterfacedef", "inherit",
  "type_parameter", "type_parameters", "interface", "$@3", "$@4",
  "delegatedef", "$@5", "$@6", "required_types", "requires",
  "interfacedef", "$@7", "interfaceref", "dispinterfaceref", "module",
  "moduledef", "storage_cls_spec", "function_specifier", "type_qualifier",
  "m_type_qual_list", "decl_spec", "unqualified_decl_spec",
  "m_decl_spec_no_type", "decl_spec_no_type", "declarator",
  "direct_declarator", "abstract_declarator",
  "abstract_declarator_no_direct", "m_abstract_declarator",
  "abstract_direct_declarator", "any_declarator",
  "any_declarator_no_direct", "m_any_declarator", "any_direct_declarator",
  "declarator_list", "m_bitfield", "struct_declarator",
  "struct_declarator_list", "init_declarator", "threading_type",
  "pointer_type", "structdef", "unqualified_type", "type", "typedef",
  "uniondef", "version", "acf_statements", "acf_int_statements",
  "acf_int_statement", "acf_interface", "acf_attributes",
  "acf_attribute_list", "acf_attribute", "allocate_option_list",
  "allocate_option", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      44,    63,    58,   124,    94,    38,    60,    62,    45,    43,
      42,    47,    37,    33,   126,   465,   466,   467,   468,   469,
      46,    91,    93,    59,   123,   125,    40,    41,    61
};
# endif

#define YYPACT_NINF -704

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-704)))

#define YYTABLE_NINF -488

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -704,   136,  1892,  -704,   -65,  -704,   -42,   -15,   306,  -704,
    -704,  -704,   306,  -704,     0,   -10,   306,  -704,   372,  -704,
    -704,  -704,  -704,    66,   237,  -704,  -704,  -704,  -704,  -704,
     306,    66,   230,    25,  -704,   306,    59,    66,   575,  -704,
    -704,   400,   405,   575,  -704,  -704,  3577,  -704,  -704,  -704,
    -704,    70,  -704,  -704,  -704,  -704,  -704,     6,  2968,   101,
     108,  -704,  -704,  -704,   408,    67,  -704,   120,  -704,   134,
    -704,   155,  -704,   117,   171,   198,   179,   185,  -704,  -704,
    -704,   272,   272,   272,    79,  3244,   188,  -704,   272,   212,
     232,  -704,    80,  -704,   -15,   172,  -704,  -704,  -704,  -704,
     301,  -704,  -704,    86,   151,  -704,  -704,  -704,   238,   177,
    -704,  -704,    82,  -704,  3244,  -704,  -704,   228,   162,   -49,
     -67,  -704,   204,  -704,   234,  -704,  -704,   236,  -704,  -704,
    -704,   244,   247,  -704,  -704,   249,  -704,  -704,  -704,   250,
     251,  -704,   252,  -704,  -704,  -704,  -704,  -704,   253,  -704,
     254,  -704,  -704,   256,  -704,  -704,  -704,   265,   266,  -704,
    -704,   267,  -704,  -704,  -704,  -704,  -704,   268,   269,   270,
     273,   274,  -704,   275,  -704,  -704,   276,  -704,   278,  -704,
    -704,   280,   281,  -704,  -704,   282,  -704,  -704,  -704,  -704,
    -704,  -704,  -704,  -704,  -704,  -704,  -704,   284,  -704,  -704,
     285,  -704,   286,   287,  -704,  -704,  -704,  -704,  -704,  -704,
    -704,   288,  -704,  -704,   289,  -704,  -704,  -704,   291,  -704,
     292,  -704,  -704,   293,   298,   300,   303,  -704,  -704,  -704,
     310,   317,  -704,  -704,   318,   319,   322,   -57,  -704,  -704,
    -704,  2025,  1164,  3244,   306,   235,   240,   414,   306,   436,
     448,   243,   304,   279,   307,   308,  -704,    79,   330,   331,
    -704,   337,   354,  3180,  -704,  -704,  -704,   569,  -704,  -704,
     342,  -704,  -704,  -704,  -704,  -704,  -704,  -704,  -704,  -704,
    -704,  -704,  -704,    79,    79,  -704,  -704,   341,   -32,  -704,
    -704,  -704,   272,  -704,  -704,  -704,   350,  -704,  -704,  -704,
     -46,  -704,  -704,   583,   360,   -40,   119,  -704,  -704,   379,
     386,   362,  -704,   364,  -704,  3152,   592,   587,   306,   942,
    3152,  3152,   598,   589,   942,   597,   600,   602,   942,  3152,
     942,   603,   610,   942,   611,   942,   942,  2434,   942,   942,
      40,   612,   616,    -4,   617,   942,  3244,   942,  3152,   942,
    3244,   241,  3244,  3244,   591,   195,   618,  3244,  3577,   398,
    -704,   396,   397,  -704,  -704,  -704,  -704,   399,  -704,   401,
    -704,   403,  -704,   118,   404,   406,  -704,  -704,  -704,   179,
     306,  -704,  3152,  -704,  -704,   409,  -704,   409,   -64,  -704,
    -704,   451,   410,   416,   307,  -704,  -704,  -704,   408,   140,
     420,  -704,   -12,  -704,  -704,    10,    96,   412,  -704,   942,
     607,  2434,  -704,  -704,    71,    80,  -704,   411,  -704,   451,
    -704,   306,   418,   431,   417,  -704,   306,   636,   636,  -704,
     128,   235,   135,  -704,   419,   444,   421,   422,   424,  -704,
    -704,  -704,  -704,  -704,  -704,  -704,  -704,  -704,   426,  -704,
     942,   942,   942,   942,   942,   942,   961,  2688,   -92,  -704,
     427,   447,   428,   453,   439,   438,   463,  2688,   442,   466,
     445,   446,  -704,   -79,   449,   452,   458,   459,   461,   462,
     467,   468,   890,   471,  3152,    49,   472,   -66,  -704,  2688,
    -704,  -704,  -704,   476,   477,   480,   481,   482,   474,   483,
     -59,   485,   475,  2469,   487,  -704,  -704,  -704,  -704,  -704,
    -704,   489,   491,   492,   493,   473,  -704,   495,   497,   499,
    -704,  3577,  -704,   672,  -704,  -704,  -704,  -704,  -704,  -704,
    -704,   -43,    79,  1532,   152,    67,  -704,  -704,   179,   521,
    -704,  -704,  -704,  3180,  -704,  1430,   526,   -62,   506,  -704,
    -704,  -704,  -704,   758,  -704,  2567,   503,   531,  -704,  -704,
    -704,  -704,  -704,  -704,   -54,  -704,  -704,   552,   528,  -704,
    -704,   163,   942,  -704,  -704,   535,  -704,    51,    53,  -704,
    3152,  -704,  3152,   512,  -704,   517,  -704,   518,  -704,  3060,
    -704,  -704,  -704,  3336,    35,    35,    35,    35,    35,    35,
    -704,  2542,   126,  3418,   272,   942,   942,   750,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   752,   942,   942,  -704,  -704,
      -3,  -704,   598,   751,  -704,   942,  -704,   755,  -704,  -704,
     753,  -704,  -704,  -704,  -704,  -704,  -704,  -704,  -704,  -704,
    -704,  -704,    49,  -704,  2158,  -704,    49,  -704,  -704,  -704,
      50,  -704,   942,  -704,  -704,  -704,  -704,  -704,  -704,   942,
    -704,  -704,  -704,  3152,  -704,  -704,  -704,  -704,  -704,  -704,
     754,  -704,  -704,  -704,  -704,   -24,   522,  -704,  -704,  2434,
    -704,   560,   179,  -704,   581,  3152,   179,    41,  -704,   164,
    -704,   451,   539,  -704,  -704,  -704,   562,   543,  1736,   542,
    -704,  -704,  -704,  2342,    71,  -704,   547,   544,   552,  3180,
    -704,  -704,   306,   563,  -704,  -704,  -704,    49,   548,    79,
     169,   306,  -704,  -704,  -704,  -704,   126,  -704,  -704,  2250,
    -704,   126,  -704,   549,    77,   272,  -704,   213,   213,  -704,
     277,   277,   160,   160,  2707,  2726,  2647,  2746,  2771,   207,
     160,   160,   -13,   -13,    35,    35,    35,  -704,  2619,  -704,
    -704,  -704,   574,  -704,   550,   579,  -704,  -704,   109,  -704,
     555,    49,   558,  -704,  2434,  -704,  -704,   561,  -704,  -704,
     451,  -704,   179,  1297,   306,   564,    79,  -704,  -704,   306,
     451,   566,   570,   179,    67,  -704,   594,  -704,  -704,  -704,
    -704,  3152,   573,  -704,  -704,  -704,  -704,  -704,   780,  -704,
    -704,    57,  -704,  -704,   585,  -704,   -91,  -704,  -704,   568,
    -704,   572,   113,  -704,   576,    49,   577,  -704,   942,  2434,
    -704,  -704,   942,  -704,  3152,  -704,  3152,  -704,   109,  -704,
    -704,  -704,   578,  -704,   595,  -704,  -704,    58,   179,  -704,
    -704,   586,   408,  -704,  -704,  -704,  -704,   451,  1634,  -704,
     588,   590,   942,  -704,    49,  -704,  -704,  -704,  -704,   109,
    -704,  -704,  -704,    35,   596,  2688,  -704,  -704,  -704,  -704,
    3180,   571,  -704,   599,    67,  -704,   179,  -704,  -704,  -704,
    -704,    36,  -704,  -704,    72,  2434,  -704,   942,   608,  -704,
    -704,   601,   604,   623,   224,  -704,  -704,   224,  -704,  -704,
     605,   179,  -704,  -704,  -704
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      11,     0,    88,     1,   309,    55,   471,   481,     0,   320,
     312,   331,     0,   399,     0,     0,     0,   319,   307,   321,
     395,   318,   322,   323,     0,   398,   325,   332,   333,   330,
       0,   323,     0,     0,   397,     0,     0,   323,     0,   327,
     396,   307,   307,   317,   462,   313,   109,     2,    27,    26,
      56,     0,    50,    28,    53,    28,    25,     0,    89,   464,
       0,   336,   463,   314,     0,     0,   474,     0,    19,     0,
      23,     0,    21,     0,     0,     0,    48,     0,    17,    16,
      24,   406,   406,   406,     0,     0,   466,   472,   406,     0,
     468,   334,     0,     4,   481,     0,   309,   310,   350,   346,
       0,     5,   358,   465,     0,   308,   324,   329,     0,   372,
     328,   352,     0,   348,     0,   326,   315,   467,     0,   469,
       0,   316,     0,   111,     0,   113,   114,     0,   115,   116,
     117,     0,     0,   120,   122,     0,   123,   124,   125,     0,
       0,   128,     0,   130,   131,   133,   132,   134,     0,   136,
       0,   138,   139,     0,   141,   142,   143,     0,     0,   146,
     147,     0,   149,   150,   151,   152,   153,     0,     0,     0,
       0,     0,   159,     0,   161,   162,     0,   164,     0,   166,
     167,   170,     0,   171,   172,     0,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,     0,   186,   187,
       0,   189,     0,     0,   192,   193,   194,   195,   196,   460,
     197,     0,   199,   458,     0,   201,   202,   203,     0,   205,
       0,   207,   208,     0,     0,     0,     0,   213,   459,   214,
       0,     0,   218,   219,     0,     0,     0,     0,    91,   223,
      51,    88,    88,     0,     0,    88,     0,   307,     0,   307,
     307,     0,   464,     0,   366,     0,   386,     0,   466,   468,
      52,   309,   473,     0,    18,    22,    20,     0,    12,    15,
       0,    49,   388,    14,   410,   407,   409,   408,   224,   225,
     226,   227,   400,     0,     0,   311,   414,   450,   413,   304,
     464,   466,   406,   468,   402,    54,     0,   493,   492,   494,
       0,   489,   482,     0,     0,     0,    88,    71,   373,     0,
       0,     0,   290,     0,   296,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   243,
       0,     0,     0,     0,     0,     0,     0,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   109,    90,
      72,     0,     0,    45,    42,    43,    44,     0,    36,     0,
      40,     0,    38,     0,     0,     0,    34,    33,    41,    48,
       0,   393,     0,    89,    46,   465,    74,   467,   469,    75,
     354,     0,     0,     0,   366,   303,   335,   339,     0,   340,
     342,   344,     0,   353,    11,     0,     0,     0,   412,     0,
       0,    77,   416,   403,     0,     0,   488,     0,    70,     0,
       7,     0,     0,   234,   239,   235,     0,     0,     0,   470,
      88,    88,    88,   104,     0,     0,     0,     0,     0,   254,
     245,   246,   247,   251,   252,   253,   248,   249,     0,   250,
       0,     0,     0,     0,     0,     0,     0,   288,     0,   286,
       0,     0,     0,     0,    99,     0,     0,   289,     0,     0,
       0,     0,    94,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   435,     0,     0,   241,   244,
      96,    97,    98,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   457,   452,   453,   454,   455,
     456,     0,     0,     0,     0,   478,   480,     0,     0,     0,
      92,   109,     8,     0,    35,    39,    37,    31,    30,    29,
      76,     0,     0,    88,    88,   367,   368,   354,    48,   384,
     337,   341,   343,     0,   338,    88,     0,    88,     0,   401,
     411,   415,   451,     0,    87,     0,     0,    81,    78,    79,
     499,   497,   500,   498,     0,   495,   490,   483,     0,   237,
     240,    88,     0,   369,   370,   374,    59,     0,     0,   461,
       0,   291,     0,     0,   476,    89,   297,     0,   110,     0,
     112,   217,   118,     0,   278,   277,   276,   279,   274,   275,
     471,     0,   423,     0,   406,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   119,   121,
       0,   126,     0,     0,   127,     0,   135,     0,   137,   140,
       0,   144,   145,   148,   154,   155,   156,   157,   158,   160,
     163,   165,   435,   400,    77,   440,   435,   437,   436,    84,
     432,   169,   243,   168,   173,   185,   188,   190,   191,     0,
     200,   204,   206,     0,   209,   210,   212,   211,   215,   216,
       0,   220,   221,   222,    93,     0,     0,    28,   377,    77,
     443,   475,    48,    47,     0,    89,    48,     0,   355,    88,
     351,     0,     0,   345,    13,   360,     0,     0,     0,     0,
      86,    85,   417,     0,     0,   491,   487,     0,   483,     0,
     236,   238,     0,     0,    60,    57,    58,     0,   468,     0,
     466,   305,   295,   294,   101,   103,   423,   285,   400,    77,
     427,   423,   424,     0,   420,   406,   404,   267,   268,   280,
     261,   262,   265,   266,   256,   257,     0,   258,   259,   260,
     264,   263,   270,   269,   272,   273,   271,   281,     0,   287,
     106,   105,     0,   100,     0,     0,    95,    83,   435,   400,
       0,   435,     0,   431,    77,   439,   242,     0,   102,   479,
       0,    10,    48,    88,     0,     0,     0,   394,   347,     0,
       0,     0,     0,    48,   380,   381,   385,    46,   362,   361,
     364,     0,     0,   302,   365,    82,    80,   496,     0,   486,
     484,     0,   371,   375,   445,   448,     0,   293,   300,     0,
     306,     0,   423,   400,     0,   435,     0,   419,     0,    77,
     426,   405,     0,   284,     0,   129,     0,   430,   435,   441,
     434,   438,     0,   198,     0,    73,    32,     0,    48,   444,
     392,   336,     0,   391,   356,   357,   349,     0,    88,   363,
       0,     0,     0,   447,     0,   292,   228,   283,   418,   435,
     428,   422,   425,   282,     0,   255,   107,   108,   433,   442,
       0,     0,   376,   337,   382,   383,    48,   485,     6,   446,
     449,     0,   421,   429,     0,    77,   387,     0,     0,   477,
     229,     0,     0,     0,    88,     9,   378,    88,   299,   231,
       0,    48,   230,   298,   379
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -704,  -704,  -704,  -704,  -704,  -704,  -704,   432,  -704,   -52,
    -704,     5,  -328,    -1,  -704,   437,  -704,  -704,  -704,  -704,
    -704,  -704,  -704,    29,  -587,  -704,  -704,  -291,  -263,  -240,
      -2,  -704,  -704,  -704,   502,  -266,  -704,  -704,  -704,  -704,
    -704,  -271,   -69,  -704,  -704,  -704,  -704,  -704,   257,    17,
     498,   178,   407,  -704,  -285,  -321,  -704,  -704,  -704,  -704,
     -73,  -325,  -704,   138,  -704,    56,    -6,   -63,  -252,   233,
     283,  -219,  -243,  -259,   309,  -703,    16,    30,    21,    32,
      28,    37,    38,   312,  -704,    20,  -704,  -704,  -704,  -704,
     456,   125,    60,    11,  -704,  -704,    39,  -704,  -704,  -704,
    -704,    45,  -704,  -704,  -704,  -704,    47,  -704,  -704,  -364,
    -503,     7,   262,   -45,   -55,  -194,  -704,  -704,  -704,  -607,
    -704,  -611,  -704,  -575,  -704,  -704,  -704,    -5,  -704,   613,
    -704,   529,    12,  -380,    19,  -704,    15,  -704,   770,   153,
    -704,  -704,   158,  -704,   464,  -704,   167
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    47,   305,    48,   685,   363,     2,   404,   241,
     687,   533,   272,   364,    50,   577,    51,    52,    53,    54,
     365,   251,    55,   366,   556,   557,   558,   559,   655,    57,
     383,   237,   473,   493,   734,   433,   501,   434,   772,   460,
     470,   238,   656,   901,   910,   422,   423,   424,   425,   290,
     487,   488,   457,   458,   459,   468,   430,   581,   586,   432,
     919,   920,   812,    60,   829,   104,    61,   657,    62,   107,
      63,    64,    65,    66,   401,   402,   367,   368,   369,   370,
     371,   372,   373,   534,   698,   374,    75,   547,   708,    76,
     392,   574,   575,   375,   426,   723,   376,   794,   921,   806,
     702,   377,   394,   801,   802,   246,   378,    81,    82,    83,
     406,   485,   602,   274,    85,   287,   288,   742,   836,   743,
     744,   658,   782,   659,   660,   691,   873,   825,   826,   289,
     511,   239,   291,    87,    88,    89,   293,   517,    93,   717,
     718,    94,    95,   300,   301,   564,   565
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      58,    49,    98,   242,   400,   382,    99,   474,   607,    84,
     102,   397,   105,    77,    86,   284,   821,    90,    67,    59,
     399,   286,    74,    69,   109,   412,   275,   275,   275,   113,
      71,    56,    68,   275,    70,   105,   105,   276,   277,    72,
      73,    78,   549,   294,   398,   476,   483,    79,   479,    80,
     481,   530,    96,   486,    97,   462,   607,   724,   262,   724,
     498,   278,   279,   280,   281,   257,   421,   780,   706,   256,
     258,   490,   243,   259,   253,   252,   604,   777,   285,   254,
     419,   783,    96,   907,    97,   309,   255,   520,   552,   407,
     408,   278,   279,   280,   281,   270,   790,   118,   120,    96,
     908,    97,   795,   560,   292,  -487,   583,   587,   278,   279,
     280,   281,    96,   296,    97,   799,   824,   313,   627,   874,
    -309,   278,   279,   280,   281,   278,   279,   280,   281,   831,
      30,   640,   536,   311,   837,  -309,     3,   244,   278,   279,
     280,   281,   875,   297,   662,   628,   310,   561,   535,    13,
     778,   662,   834,   358,   770,   209,   714,   771,   641,   213,
     298,   800,    13,   546,   415,    91,    13,   314,   299,    46,
    -309,   663,   398,   688,  -310,   359,   568,   491,   671,   605,
     606,   607,   106,   715,   -66,  -309,   416,   904,   284,   228,
     580,   582,   582,   689,   286,   420,   245,   852,   543,   410,
     398,   515,   516,   847,   411,   544,   850,   622,   623,   624,
     700,   791,   550,   604,   284,   284,    92,   625,   626,   492,
     286,   286,   707,   745,   101,   878,   605,   606,   607,   608,
     609,   610,   611,   111,   607,   832,   100,   275,   381,    58,
      58,   105,   386,   105,   105,   562,   108,   413,    84,    84,
     684,   285,   884,    86,    86,   438,    90,    90,    59,    59,
     881,   112,   380,   824,   110,   625,   626,   543,   722,   653,
     115,   909,    16,   888,   871,   891,   848,   285,   285,   563,
     410,   410,   543,   263,   400,   654,   784,   721,   725,   911,
     726,   397,   303,   694,   697,   114,   605,   606,   607,   282,
     399,   610,   611,   240,   902,   118,   120,   582,   410,    96,
     304,    97,   285,   839,   774,   283,   282,   531,   912,   -62,
    -309,   116,   435,   735,   398,    13,   121,   461,   463,   653,
     879,   421,   283,   738,   -61,   484,   475,   284,   690,   740,
     410,   260,   769,   286,   410,   654,   738,   267,   267,   739,
      46,   268,   527,   264,  -232,   502,   263,   410,   569,    46,
     541,    20,   739,   579,   797,   499,    46,   265,   798,   504,
     584,   512,   513,   505,   285,   103,   519,    97,   620,   621,
     622,   623,   624,    46,   787,   306,    25,   696,   266,   532,
     625,   626,   540,   308,    46,    46,   312,   785,  -233,   803,
     285,   603,  -301,   117,   269,    97,  -301,   788,   119,   484,
      97,   261,   271,    97,   549,   285,   548,   385,   273,    97,
     573,   -63,   816,   618,   619,   620,   621,   622,   623,   624,
     585,   620,   621,   622,   623,   624,    34,   625,   626,   387,
     315,    97,   805,   625,   626,   295,   506,   507,   508,   509,
     510,   388,    40,    97,     4,    46,    97,   918,   804,   697,
     400,   -64,  -309,   284,   855,   -65,    46,   397,   549,   286,
     316,   307,   317,   740,   384,   866,   399,   389,   740,   285,
     318,   840,   398,   319,   549,   320,   321,   322,   323,   324,
     325,   652,   326,   618,   619,   620,   621,   622,   623,   624,
     398,   327,   328,   329,   330,   331,   332,   625,   626,   333,
     334,   335,   336,   390,   337,   549,   338,   339,   340,   391,
     341,   342,   343,   344,   345,   346,   285,   347,   348,   349,
     892,   695,   693,   741,   350,   828,   351,   -67,   603,   352,
      84,   863,   393,    58,    49,    86,   353,   854,    90,   275,
      59,   899,    84,   354,   355,   356,    77,    86,   357,   746,
      90,    67,    59,   -68,   -69,    74,    69,   396,   906,   740,
    -337,   398,   403,    71,    56,    68,   405,    70,   886,   409,
     887,   862,    72,    73,    78,   781,   414,   727,   417,   729,
      79,   427,    80,   924,   730,   728,   463,   418,   428,   429,
     431,   436,   859,   437,   464,   466,   469,   514,   895,   471,
     439,   472,   477,   440,   441,   442,   443,   444,   445,   478,
     480,   494,   913,    11,   894,   495,   497,   518,   694,   521,
     522,   400,   524,   523,   525,   793,   526,   528,   397,   529,
     542,   571,   576,  -309,   537,   567,   285,   399,   398,   551,
     285,   538,   484,   570,   589,   572,   588,   630,   590,   591,
     284,   592,   593,   632,   629,   631,   286,   741,   830,   633,
     835,   398,   741,   635,   582,   634,   637,   582,    23,   636,
     463,   686,   638,   639,   669,   673,   642,   484,   701,   643,
     275,    26,    27,    28,    29,   644,   645,   446,   646,   647,
     841,    31,   257,   680,   648,   649,   811,   258,   651,   661,
     259,   484,   252,   664,   665,    84,   573,   666,   667,   668,
     670,   285,   672,   285,   675,   285,   676,   284,   677,   678,
     679,   467,   681,   286,   682,   467,   683,   484,   705,   709,
     712,   713,   716,   482,   719,   722,   489,    37,   447,   731,
     732,   733,    39,   749,   489,   767,   503,   773,   775,   792,
     789,   439,   776,   741,   440,   441,   442,   443,   444,   445,
     796,   245,   285,   807,   808,   285,   809,   814,    92,   819,
     823,   827,   484,   448,   844,   870,   838,   845,   573,   846,
     285,    58,   849,   860,   861,   851,   449,   872,   853,   864,
      84,   858,   876,   865,   867,    86,   869,   905,    90,   877,
      59,   890,   868,   880,   882,   889,   467,   555,   257,  -389,
     914,   897,   450,   898,   465,   451,   452,   553,   720,   285,
     454,   455,  -390,   903,   915,   917,   545,   484,   923,   554,
     786,   916,   285,   456,   922,   500,   813,   822,   446,   699,
     539,   463,   703,   463,   857,   736,   893,   594,   595,   596,
     597,   598,   599,   601,   302,   578,   695,   693,   285,   900,
     395,   820,   496,   285,   818,    84,     0,     0,     0,   566,
      86,   817,     0,    90,     0,    59,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   447,
       0,     0,     0,   484,     0,     0,     0,     0,     0,   605,
     606,   607,   608,   609,   610,   611,   612,   613,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   448,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   439,     0,   449,   440,   441,
     442,   443,   444,   445,     0,     0,     0,     0,     0,     0,
     597,     0,     0,     0,   439,     0,   600,   440,   441,   442,
     443,   444,   445,   450,     0,     0,   451,   452,   453,     0,
       0,   454,   455,     0,     0,     0,     0,     0,     0,     0,
     710,     0,     0,     0,   456,     0,     0,     0,     0,     0,
       0,     0,     9,     0,    10,     0,     0,     0,     0,    11,
       0,     0,   747,   748,    13,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   446,   768,     0,     0,     0,     0,    17,     0,
       0,     0,   467,     0,   247,    19,     0,     0,     0,     0,
      20,   446,     0,     0,    21,     0,     0,    22,     0,     0,
       0,     0,     0,     0,    23,     0,     0,     0,     0,   489,
       0,     0,     0,     0,     0,    25,     0,    26,    27,    28,
      29,     0,     0,   447,     0,     0,     0,    31,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   614,   447,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,     0,     0,     0,     0,     0,   448,     0,
     625,   626,     0,     0,     0,    34,     0,   650,     0,     0,
       0,   449,    36,    37,    38,     0,     0,   448,    39,     0,
       0,    40,     0,     0,   249,     0,     0,     0,     0,     0,
     449,     0,     0,   250,     0,    43,     0,   450,     0,     0,
     451,   452,   453,    44,    45,   454,   455,     4,     5,     6,
       0,     0,     0,     0,     0,     0,   450,     0,   456,   451,
     452,   453,     0,     0,   454,   455,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   456,     0,     8,
       0,     0,     0,     0,     0,     9,     0,    10,     0,     0,
       0,     0,    11,    12,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,    14,     0,   361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
       0,    17,     0,     0,     0,   883,     0,    18,    19,   885,
       0,     0,     0,    20,     0,     0,     0,    21,     0,     0,
      22,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,     0,     0,     0,    24,   362,     0,     0,    25,   467,
      26,    27,    28,    29,    30,     0,     0,     0,     0,     0,
      31,     0,     0,     0,     0,     0,     0,    32,     0,     0,
       4,     5,     6,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    34,     0,
       0,     0,     8,     0,    35,    36,    37,    38,     9,     0,
      10,    39,     0,     0,    40,    11,    12,    41,     0,     0,
      13,     0,     0,     0,     0,     0,    42,    14,    43,   361,
       0,     0,     0,     0,     0,     0,    44,    45,     0,     0,
       0,    16,     0,     0,    17,     0,     0,     0,     0,     0,
      18,    19,     0,     0,     0,     0,    20,     0,     0,     0,
      21,     0,     0,    22,     0,    46,     0,     0,     0,   379,
      23,     0,     0,     0,     0,     0,     0,    24,   362,     0,
       0,    25,     0,    26,    27,    28,    29,    30,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
      32,     0,     0,     4,     5,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    34,     0,     0,     0,     8,     0,    35,    36,    37,
      38,     9,     0,    10,    39,     0,     0,    40,    11,    12,
      41,     0,     0,    13,     0,     0,     0,     0,     0,    42,
      14,    43,    15,     0,     0,     0,     0,     0,     0,    44,
      45,     0,     0,     0,    16,     0,     0,    17,     0,     0,
       0,     0,     0,    18,    19,     0,     0,     0,     0,    20,
       0,     0,     0,    21,     0,     0,    22,     0,    46,     0,
       0,     0,   856,    23,     0,     4,     5,     6,     0,     0,
      24,     0,     0,     0,    25,     0,    26,    27,    28,    29,
      30,     0,     0,     0,     0,     0,    31,     0,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     9,     0,    10,     0,     0,     0,     0,
      11,    33,     0,     0,     0,    13,     0,     0,     0,     0,
       0,     0,    14,     0,    34,     0,     0,     0,     0,     0,
      35,    36,    37,    38,     0,     0,     0,    39,     0,    17,
      40,     0,     0,    41,     0,    18,    19,     0,     0,     0,
       0,    20,    42,     0,    43,    21,     0,     0,    22,     0,
       0,     0,    44,    45,     0,    23,     0,     4,     5,     6,
       0,     0,    24,     0,     0,     0,    25,     0,    26,    27,
      28,    29,     0,     0,     0,     0,     0,     0,    31,     0,
       0,    46,     0,     0,     0,   704,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     9,     0,    10,     0,     0,
       0,     0,    11,    33,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,    14,     0,    34,     0,     0,     0,
       0,     0,     0,    36,    37,    38,     0,     0,     0,    39,
       0,    17,    40,     0,     0,    41,     0,    18,    19,     0,
       0,     0,     0,    20,    42,     0,    43,    21,     0,     0,
      22,     0,     0,     0,    44,    45,     0,    23,     0,     4,
       0,     6,     0,     0,    24,     0,     0,     0,    25,     0,
      26,    27,    28,    29,     0,     0,     0,     0,     0,     0,
      31,     0,     0,    46,     0,     0,     0,   692,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,     0,    10,
       0,     0,     0,     0,    11,    33,     0,     0,     0,    13,
       0,     0,     0,     0,     0,     0,     0,     0,    34,     0,
       0,     0,     0,     0,     0,    36,    37,    38,     0,     0,
       0,    39,     0,    17,    40,     0,     0,    41,     0,   247,
      19,     0,     0,     0,     0,    20,    42,     0,    43,    21,
       0,     0,    22,     0,     0,     0,    44,    45,     0,    23,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      25,     0,    26,    27,    28,    29,     0,     0,     0,     0,
       0,     0,    31,     0,     0,    46,     0,     0,     0,   896,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    -3,     0,     0,     4,     5,     6,     0,     0,
      34,     0,     0,     0,     0,     0,     0,    36,    37,    38,
       7,     0,     0,    39,     0,     0,    40,     0,     0,   249,
       0,     0,     0,     0,     0,     0,     0,     8,   250,     0,
      43,     0,     0,     9,     0,    10,     0,     0,    44,    45,
      11,    12,     0,     0,     0,    13,     0,     0,     0,     0,
       0,     0,    14,     0,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    46,     0,    17,
       0,   810,     0,     0,     0,    18,    19,     0,     0,     0,
       0,    20,     0,     0,     0,    21,     0,     0,    22,     0,
       0,     0,     0,     0,     0,    23,     0,     0,     0,     0,
       0,     0,    24,     0,     0,     0,    25,     0,    26,    27,
      28,    29,    30,     0,     0,     0,     0,     0,    31,     0,
       0,     0,     0,     0,     0,    32,     0,     0,     4,     5,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   360,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    34,     0,     0,     0,
       8,     0,    35,    36,    37,    38,     9,     0,    10,    39,
       0,     0,    40,    11,    12,    41,     0,     0,    13,     0,
       0,     0,     0,     0,    42,    14,    43,   361,     0,     0,
       0,     0,     0,     0,    44,    45,     0,     0,     0,    16,
       0,     0,    17,     0,     0,     0,     0,     0,    18,    19,
       0,     0,     0,     0,    20,     0,     0,     0,    21,     0,
       0,    22,     0,    46,     0,     0,     0,     0,    23,     0,
       0,     0,     0,     0,     0,    24,   362,     0,     0,    25,
       0,    26,    27,    28,    29,    30,     0,     0,     0,     0,
       0,    31,     0,     0,     0,     0,     0,     0,    32,     0,
       0,     4,     0,     6,     0,     0,     0,     0,     0,     0,
     278,   279,   280,   281,     0,     0,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    34,
       0,     0,     0,     0,     0,    35,    36,    37,    38,     9,
       0,    10,    39,     0,     0,    40,    11,     0,    41,     0,
       0,    13,     0,     0,     0,     0,     0,    42,     0,    43,
       0,     0,     0,     0,     0,     0,     0,    44,    45,     0,
       0,     0,     0,     0,     0,    17,     0,     0,     0,     0,
       0,   247,    19,     0,     0,     0,     0,    20,     0,     0,
       0,    21,     0,     4,    22,     6,    46,     0,     0,     0,
       0,    23,   278,   279,   280,   281,     0,     0,     0,     0,
       0,     0,    25,     0,    26,    27,    28,    29,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     9,     0,    10,     0,     0,     0,     0,    11,     0,
       0,     0,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,     0,     0,    17,     0,    36,
      37,    38,     0,   247,    19,    39,     0,     0,    40,    20,
       0,   249,     0,    21,     0,     4,    22,     6,     0,     0,
     250,     0,    43,    23,     0,     0,     0,     0,     0,     0,
      44,    45,     0,     0,    25,     0,    26,    27,    28,    29,
     815,     0,     0,     0,     0,     0,    31,     0,   779,     0,
       0,     0,     0,     9,     0,    10,     0,     0,     0,    46,
      11,     0,     0,     0,     0,    13,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    34,     0,     0,     0,     0,    17,
       0,    36,    37,    38,     0,   247,    19,    39,     0,     0,
      40,    20,     0,   249,     0,    21,     0,     4,    22,     6,
       0,     0,   250,     0,    43,    23,     0,     0,     0,     0,
       0,     0,    44,    45,     0,     0,    25,     0,    26,    27,
      28,    29,     0,     0,     0,     0,     0,     0,    31,     0,
     833,     0,     0,     0,     0,     9,     0,    10,     0,     0,
       0,    46,    11,     0,     0,     0,     0,    13,   605,   606,
     607,   608,   609,   610,   611,   612,   613,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    34,     0,     0,     0,
       0,    17,     0,    36,    37,    38,     0,   247,    19,    39,
       0,     0,    40,    20,     0,   249,     0,    21,     0,     0,
      22,     0,     0,     0,   250,     0,    43,    23,     0,     0,
       0,     0,     0,     0,    44,    45,     0,     0,    25,     0,
      26,    27,    28,    29,     0,     0,     0,     0,     0,     0,
      31,   605,   606,   607,   608,   609,   610,   611,   612,   613,
       0,     0,     0,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   605,   606,   607,   608,
     609,   610,   611,   612,   613,     0,     0,     0,    34,     0,
       0,     0,     0,     0,     0,    36,    37,    38,     0,     0,
       0,    39,     0,     0,    40,     0,     0,   249,     0,     0,
       0,     0,     0,     0,     0,     0,   250,     0,    43,     0,
       0,     0,     0,     0,     0,     0,    44,    45,   605,   606,
     607,   608,   609,   610,   611,   612,   613,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,   605,   606,   607,   608,
     609,   610,   611,   612,   613,     0,     0,     0,     0,     0,
     614,     0,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,     0,     0,     0,     0,     0,     0,     0,   625,
     626,     0,     0,     0,     0,     0,   674,   605,   606,   607,
     608,   609,   610,   611,   612,   613,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   605,   606,   607,   608,
     609,   610,   611,     0,   613,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   605,   606,   607,   608,   609,
     610,   611,     0,   614,     0,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   605,   606,   607,   608,   609,
     610,   611,   625,   626,     0,     0,     0,     0,   614,   737,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     605,   606,   607,   608,   609,   610,   611,   625,   626,   711,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     614,     0,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,     0,     0,     0,     0,     0,     0,     0,   625,
     626,   843,     0,     0,     0,     0,     0,     0,   614,   842,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
       0,     0,     0,     0,     0,     0,     0,   625,   626,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   614,
       0,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,     0,     0,     0,     0,     0,     0,     0,   625,   626,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
       0,     0,     0,     0,     0,     0,     0,   625,   626,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,     0,
       0,     0,     0,     0,     0,     0,   625,   626,     0,     0,
     616,   617,   618,   619,   620,   621,   622,   623,   624,     0,
       0,     4,     0,     6,     0,     0,   625,   626,     0,     0,
       0,     0,     0,     0,     0,     0,   617,   618,   619,   620,
     621,   622,   623,   624,     0,     0,     0,     0,     0,     0,
       0,   625,   626,     8,     0,     0,     0,     0,     0,     9,
       0,    10,     0,     0,     0,     0,    11,    12,     0,     0,
       0,    13,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -359,     0,     0,    17,     0,     0,     0,     0,
       0,   247,    19,     0,     0,     0,     0,    20,     0,     0,
       0,    21,     0,     4,    22,     6,   464,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    25,     0,    26,    27,    28,    29,    30,     0,
       0,   248,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     9,     0,    10,     0,     0,     0,     0,    11,     0,
       0,     0,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,     0,     0,    17,    35,    36,
      37,    38,     0,   247,    19,    39,     0,     0,    40,    20,
       0,   249,     0,    21,     0,     4,    22,     6,     0,     0,
     250,     0,    43,    23,     0,     0,     0,     0,     0,     0,
      44,    45,     0,     0,    25,     0,    26,    27,    28,    29,
       0,     0,     0,     4,     0,    97,    31,     0,     0,     0,
       0,     0,     0,     9,     0,    10,     0,     0,     0,     0,
      11,     0,     0,     0,     0,    13,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     9,     0,    10,    34,     0,     0,     0,    11,    17,
       0,    36,    37,    38,     0,   247,    19,    39,     0,     0,
      40,    20,     0,   249,     0,    21,     0,     4,    22,     6,
       0,     0,   250,     0,    43,    23,     0,    17,     0,     0,
       0,     0,    44,    45,    19,     0,    25,     0,    26,    27,
      28,    29,     0,    21,     0,     0,    22,     0,    31,     0,
       0,     0,     0,    23,     0,     9,     0,    10,     0,     0,
       0,     0,    11,     0,     0,     0,    26,    27,    28,    29,
       0,     0,     0,     0,     0,     0,    31,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    34,     0,     0,     0,
       0,    17,     0,    36,    37,    38,     0,   247,    19,    39,
       0,     0,    40,     0,     0,   249,     0,    21,     0,     0,
      22,   600,     0,     0,   250,     0,    43,    23,     0,     0,
       0,     0,    37,    38,    44,    45,     0,    39,     0,     0,
      26,    27,    28,    29,     0,     0,     0,     0,     0,     0,
      31,     0,     0,     0,    43,     0,     0,     9,     0,    10,
       0,     0,     0,    45,    11,     0,     0,     0,     0,    13,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    17,     0,    36,    37,    38,     0,   247,
      19,    39,     0,   600,     0,    20,     0,   249,     0,    21,
       0,     0,    22,     0,     0,     0,   250,     0,    43,    23,
       0,     0,     0,     0,     0,     0,    44,    45,     0,     0,
      25,     0,    26,    27,    28,    29,     0,     0,     0,     9,
       0,    10,    31,     0,     0,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    17,     0,     0,     0,     0,
      34,   247,    19,     0,     0,     0,     0,    36,    37,    38,
       0,    21,     0,    39,    22,     0,    40,     0,     0,   249,
       0,    23,     0,     0,     0,     0,     0,     0,   250,     0,
      43,     0,     0,     0,    26,    27,    28,    29,    44,    45,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
      37,    38,     0,     0,     0,    39,     0,     0,     0,     0,
       0,   249,     0,     0,     0,     0,   122,   123,     0,     0,
     250,   124,    43,   125,   126,   127,   128,   129,     0,   130,
      44,    45,   131,     0,   132,     0,     0,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,     0,   142,     0,
     143,   144,   145,     0,   146,   147,   148,   149,   150,   151,
     152,     0,   153,     0,     0,   154,   155,   156,   157,   158,
       0,     0,   159,   160,   161,   162,     0,     0,   163,   164,
       0,   165,   166,     0,   167,   168,   169,   170,   171,   172,
       0,   173,   174,   175,   176,   177,   178,     0,     0,   179,
       0,     0,   180,     0,     0,     0,     0,     0,   181,   182,
       0,   183,   184,     0,   185,   186,   187,     0,     0,     0,
       0,   188,   189,   190,     0,   191,   192,   193,     0,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,     0,   214,   215,     0,   216,   217,     0,     0,     0,
       0,     0,   218,     0,     0,   219,     0,   220,   221,   222,
       0,     0,   223,   224,   225,   226,     0,     0,   227,     0,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
       0,   236
};

static const yytype_int16 yycheck[] =
{
       2,     2,     8,    55,   263,   245,    12,   328,    21,     2,
      16,   263,    18,     2,     2,    84,   719,     2,     2,     2,
     263,    84,     2,     2,    30,   288,    81,    82,    83,    35,
       2,     2,     2,    88,     2,    41,    42,    82,    83,     2,
       2,     2,   406,    88,   263,   330,   337,     2,   333,     2,
     335,   379,     3,   338,     5,   321,    21,     6,    64,     6,
     345,    12,    13,    14,    15,    58,   306,   654,   130,    58,
      58,    31,    66,    58,    58,    58,   456,   652,    84,    58,
     120,   656,     3,    47,     5,     3,    58,   358,   409,   283,
     284,    12,    13,    14,    15,    75,   120,    41,    42,     3,
      64,     5,   689,    32,    85,   120,   431,   432,    12,    13,
      14,    15,     3,    33,     5,    74,   727,   184,   210,   210,
     184,    12,    13,    14,    15,    12,    13,    14,    15,   736,
     120,   210,   391,   114,   741,   184,     0,   131,    12,    13,
      14,    15,   233,    63,   210,   237,    64,    76,   391,    53,
     653,   210,   739,   210,   157,   159,   210,   160,   237,   163,
      80,   120,    53,   153,   210,   230,    53,   234,    88,   231,
     234,   237,   391,   216,   216,   232,   419,   137,   237,    19,
      20,    21,   116,   237,   233,   234,   232,   890,   257,   193,
     430,   431,   432,   236,   257,   235,   190,   784,   210,   231,
     419,     6,     7,   778,   236,   217,   781,   220,   221,   222,
     538,   235,   406,   593,   283,   284,   231,   230,   231,   179,
     283,   284,   547,   603,   234,   832,    19,    20,    21,    22,
      23,    24,    25,     3,    21,   738,   236,   292,   244,   241,
     242,   247,   248,   249,   250,   174,     9,   292,   241,   242,
     521,   257,   839,   241,   242,   318,   241,   242,   241,   242,
     835,   236,   243,   874,    31,   230,   231,   210,   210,   220,
      37,   235,    74,   848,   217,   217,   779,   283,   284,   208,
     231,   231,   210,   216,   543,   236,   236,   572,   237,   217,
     237,   543,   120,   533,   534,   236,    19,    20,    21,   220,
     543,    24,    25,   233,   879,   249,   250,   547,   231,     3,
       9,     5,   318,   236,   635,   236,   220,   380,   905,   233,
     234,    38,   315,   589,   543,    53,    43,   320,   321,   220,
     833,   571,   236,   220,   233,   337,   329,   406,   532,   602,
     231,   233,   627,   406,   231,   236,   220,   230,   230,   236,
     231,   234,   234,   233,   235,   348,   216,   231,   421,   231,
     220,    89,   236,   235,   692,   346,   231,   233,   696,   350,
     235,   352,   353,   132,   380,     3,   357,     5,   218,   219,
     220,   221,   222,   231,   669,   234,   114,   235,   233,   382,
     230,   231,   398,   216,   231,   231,   234,   660,   235,   235,
     406,   456,   233,     3,   233,     5,   237,   673,     3,   411,
       5,     3,   233,     5,   778,   421,   405,     3,   233,     5,
     426,   233,   713,   216,   217,   218,   219,   220,   221,   222,
     432,   218,   219,   220,   221,   222,   164,   230,   231,     3,
     236,     5,   701,   230,   231,   233,   205,   206,   207,   208,
     209,     3,   180,     5,     3,   231,     5,   233,   701,   699,
     719,   233,   234,   532,   792,   233,   231,   719,   832,   532,
     236,   233,   236,   736,   234,   803,   719,   234,   741,   485,
     236,   744,   701,   236,   848,   236,   236,   236,   236,   236,
     236,   484,   236,   216,   217,   218,   219,   220,   221,   222,
     719,   236,   236,   236,   236,   236,   236,   230,   231,   236,
     236,   236,   236,   234,   236,   879,   236,   236,   236,   212,
     236,   236,   236,   236,   236,   236,   532,   236,   236,   236,
     858,   533,   533,   602,   236,   729,   236,   233,   593,   236,
     533,   800,   234,   545,   545,   533,   236,   790,   533,   604,
     533,   872,   545,   236,   236,   236,   545,   545,   236,   604,
     545,   545,   545,   233,   233,   545,   545,   230,   896,   832,
     216,   790,     3,   545,   545,   545,   234,   545,   844,   238,
     846,   800,   545,   545,   545,   654,   236,   580,     5,   582,
     545,   212,   545,   921,   582,   580,   589,   237,   212,   237,
     236,     9,   796,    16,     6,    16,     9,    16,   867,     9,
       3,     9,     9,     6,     7,     8,     9,    10,    11,     9,
       9,     9,   907,    48,   867,     9,     9,     9,   868,   231,
     234,   890,   233,   236,   233,   687,   233,   233,   890,   233,
     220,   210,     6,   234,   234,   234,   652,   890,   867,   237,
     656,   235,   654,   235,   210,   238,   237,   210,   237,   237,
     729,   237,   236,   210,   237,   237,   729,   736,   731,   230,
     739,   890,   741,   210,   914,   237,   210,   917,   103,   237,
     673,     9,   237,   237,   210,   210,   237,   689,   167,   237,
     745,   116,   117,   118,   119,   237,   237,    90,   237,   237,
     745,   126,   695,   230,   237,   237,   708,   695,   237,   237,
     695,   713,   695,   237,   237,   708,   722,   237,   237,   237,
     237,   727,   237,   729,   237,   731,   237,   796,   237,   237,
     237,   324,   237,   796,   237,   328,   237,   739,   212,   233,
     237,   210,   190,   336,   216,   210,   339,   172,   141,   237,
     233,   233,   177,     3,   347,     3,   349,     6,     3,   237,
       6,     3,     9,   832,     6,     7,     8,     9,    10,    11,
     210,   190,   778,   234,   212,   781,   233,   235,   231,   235,
     217,   233,   784,   176,   210,     5,   237,   237,   794,   210,
     796,   793,   237,   799,   800,   237,   189,   212,   237,   233,
     793,   237,   234,   233,   210,   793,   233,   236,   793,   237,
     793,   216,   807,   237,   237,   237,   409,   410,   811,   233,
     212,   233,   215,   233,   322,   218,   219,   220,   571,   835,
     223,   224,   233,   237,   233,   212,   404,   839,   233,   232,
     662,   237,   848,   236,   917,   347,   708,   722,    90,   537,
     394,   844,   543,   846,   794,   593,   862,   450,   451,   452,
     453,   454,   455,   456,    94,   428,   868,   868,   874,   874,
     257,   718,   343,   879,   716,   868,    -1,    -1,    -1,   415,
     868,   714,    -1,   868,    -1,   868,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,    -1,    -1,   905,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,   189,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,
     553,    -1,    -1,    -1,     3,    -1,     5,     6,     7,     8,
       9,    10,    11,   215,    -1,    -1,   218,   219,   220,    -1,
      -1,   223,   224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     232,    -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    48,
      -1,    -1,   605,   606,    53,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,    90,   626,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    -1,   635,    -1,    83,    84,    -1,    -1,    -1,    -1,
      89,    90,    -1,    -1,    93,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,   662,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,   117,   118,
     119,    -1,    -1,   141,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   211,   141,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,    -1,    -1,    -1,    -1,    -1,   176,    -1,
     230,   231,    -1,    -1,    -1,   164,    -1,   237,    -1,    -1,
      -1,   189,   171,   172,   173,    -1,    -1,   176,   177,    -1,
      -1,   180,    -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,
     189,    -1,    -1,   192,    -1,   194,    -1,   215,    -1,    -1,
     218,   219,   220,   202,   203,   223,   224,     3,     4,     5,
      -1,    -1,    -1,    -1,    -1,    -1,   215,    -1,   236,   218,
     219,   220,    -1,    -1,   223,   224,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    53,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,
      -1,    77,    -1,    -1,    -1,   838,    -1,    83,    84,   842,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    93,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,   114,   872,
     116,   117,   118,   119,   120,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,
       3,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,
      -1,    -1,    35,    -1,   170,   171,   172,   173,    41,    -1,
      43,   177,    -1,    -1,   180,    48,    49,   183,    -1,    -1,
      53,    -1,    -1,    -1,    -1,    -1,   192,    60,   194,    62,
      -1,    -1,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,
      -1,    74,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      83,    84,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      93,    -1,    -1,    96,    -1,   231,    -1,    -1,    -1,   235,
     103,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,   114,    -1,   116,   117,   118,   119,   120,    -1,    -1,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
     133,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   164,    -1,    -1,    -1,    35,    -1,   170,   171,   172,
     173,    41,    -1,    43,   177,    -1,    -1,   180,    48,    49,
     183,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,   192,
      60,   194,    62,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,    -1,    -1,    -1,    74,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    89,
      -1,    -1,    -1,    93,    -1,    -1,    96,    -1,   231,    -1,
      -1,    -1,   235,   103,    -1,     3,     4,     5,    -1,    -1,
     110,    -1,    -1,    -1,   114,    -1,   116,   117,   118,   119,
     120,    -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      48,   151,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    -1,   164,    -1,    -1,    -1,    -1,    -1,
     170,   171,   172,   173,    -1,    -1,    -1,   177,    -1,    77,
     180,    -1,    -1,   183,    -1,    83,    84,    -1,    -1,    -1,
      -1,    89,   192,    -1,   194,    93,    -1,    -1,    96,    -1,
      -1,    -1,   202,   203,    -1,   103,    -1,     3,     4,     5,
      -1,    -1,   110,    -1,    -1,    -1,   114,    -1,   116,   117,
     118,   119,    -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,
      -1,   231,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    48,   151,    -1,    -1,    -1,    53,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    -1,   164,    -1,    -1,    -1,
      -1,    -1,    -1,   171,   172,   173,    -1,    -1,    -1,   177,
      -1,    77,   180,    -1,    -1,   183,    -1,    83,    84,    -1,
      -1,    -1,    -1,    89,   192,    -1,   194,    93,    -1,    -1,
      96,    -1,    -1,    -1,   202,   203,    -1,   103,    -1,     3,
      -1,     5,    -1,    -1,   110,    -1,    -1,    -1,   114,    -1,
     116,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,   231,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    48,   151,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,
      -1,    -1,    -1,    -1,    -1,   171,   172,   173,    -1,    -1,
      -1,   177,    -1,    77,   180,    -1,    -1,   183,    -1,    83,
      84,    -1,    -1,    -1,    -1,    89,   192,    -1,   194,    93,
      -1,    -1,    96,    -1,    -1,    -1,   202,   203,    -1,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,   117,   118,   119,    -1,    -1,    -1,    -1,
      -1,    -1,   126,    -1,    -1,   231,    -1,    -1,    -1,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     0,    -1,    -1,     3,     4,     5,    -1,    -1,
     164,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,   173,
      18,    -1,    -1,   177,    -1,    -1,   180,    -1,    -1,   183,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,   192,    -1,
     194,    -1,    -1,    41,    -1,    43,    -1,    -1,   202,   203,
      48,    49,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    74,   231,    -1,    77,
      -1,   235,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    93,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,
      -1,    -1,   110,    -1,    -1,    -1,   114,    -1,   116,   117,
     118,   119,   120,    -1,    -1,    -1,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,     3,     4,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,
      35,    -1,   170,   171,   172,   173,    41,    -1,    43,   177,
      -1,    -1,   180,    48,    49,   183,    -1,    -1,    53,    -1,
      -1,    -1,    -1,    -1,   192,    60,   194,    62,    -1,    -1,
      -1,    -1,    -1,    -1,   202,   203,    -1,    -1,    -1,    74,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    83,    84,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,    -1,
      -1,    96,    -1,   231,    -1,    -1,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,   114,
      -1,   116,   117,   118,   119,   120,    -1,    -1,    -1,    -1,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,
      -1,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      12,    13,    14,    15,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,
      -1,    -1,    -1,    -1,    -1,   170,   171,   172,   173,    41,
      -1,    43,   177,    -1,    -1,   180,    48,    -1,   183,    -1,
      -1,    53,    -1,    -1,    -1,    -1,    -1,   192,    -1,   194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    89,    -1,    -1,
      -1,    93,    -1,     3,    96,     5,   231,    -1,    -1,    -1,
      -1,   103,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,   117,   118,   119,    -1,    -1,
      -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   164,    -1,    -1,    -1,    -1,    77,    -1,   171,
     172,   173,    -1,    83,    84,   177,    -1,    -1,   180,    89,
      -1,   183,    -1,    93,    -1,     3,    96,     5,    -1,    -1,
     192,    -1,   194,   103,    -1,    -1,    -1,    -1,    -1,    -1,
     202,   203,    -1,    -1,   114,    -1,   116,   117,   118,   119,
      28,    -1,    -1,    -1,    -1,    -1,   126,    -1,   220,    -1,
      -1,    -1,    -1,    41,    -1,    43,    -1,    -1,    -1,   231,
      48,    -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,    -1,    77,
      -1,   171,   172,   173,    -1,    83,    84,   177,    -1,    -1,
     180,    89,    -1,   183,    -1,    93,    -1,     3,    96,     5,
      -1,    -1,   192,    -1,   194,   103,    -1,    -1,    -1,    -1,
      -1,    -1,   202,   203,    -1,    -1,   114,    -1,   116,   117,
     118,   119,    -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,
     220,    -1,    -1,    -1,    -1,    41,    -1,    43,    -1,    -1,
      -1,   231,    48,    -1,    -1,    -1,    -1,    53,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,
      -1,    77,    -1,   171,   172,   173,    -1,    83,    84,   177,
      -1,    -1,   180,    89,    -1,   183,    -1,    93,    -1,    -1,
      96,    -1,    -1,    -1,   192,    -1,   194,   103,    -1,    -1,
      -1,    -1,    -1,    -1,   202,   203,    -1,    -1,   114,    -1,
     116,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    -1,    -1,   164,    -1,
      -1,    -1,    -1,    -1,    -1,   171,   172,   173,    -1,    -1,
      -1,   177,    -1,    -1,   180,    -1,    -1,   183,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,   194,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   202,   203,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,    -1,    -1,    -1,    -1,    -1,   237,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,    19,    20,    21,    22,    23,
      24,    25,   230,   231,    -1,    -1,    -1,    -1,   211,   237,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      19,    20,    21,    22,    23,    24,    25,   230,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,
     231,   232,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,   231,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,   231,    -1,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,    -1,
      -1,     3,    -1,     5,    -1,    -1,   230,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   230,   231,    35,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    74,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    89,    -1,    -1,
      -1,    93,    -1,     3,    96,     5,     6,    -1,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,   117,   118,   119,   120,    -1,
      -1,   123,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   164,    -1,    -1,    -1,    -1,    77,   170,   171,
     172,   173,    -1,    83,    84,   177,    -1,    -1,   180,    89,
      -1,   183,    -1,    93,    -1,     3,    96,     5,    -1,    -1,
     192,    -1,   194,   103,    -1,    -1,    -1,    -1,    -1,    -1,
     202,   203,    -1,    -1,   114,    -1,   116,   117,   118,   119,
      -1,    -1,    -1,     3,    -1,     5,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      48,    -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    43,   164,    -1,    -1,    -1,    48,    77,
      -1,   171,   172,   173,    -1,    83,    84,   177,    -1,    -1,
     180,    89,    -1,   183,    -1,    93,    -1,     3,    96,     5,
      -1,    -1,   192,    -1,   194,   103,    -1,    77,    -1,    -1,
      -1,    -1,   202,   203,    84,    -1,   114,    -1,   116,   117,
     118,   119,    -1,    93,    -1,    -1,    96,    -1,   126,    -1,
      -1,    -1,    -1,   103,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    48,    -1,    -1,    -1,   116,   117,   118,   119,
      -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,
      -1,    77,    -1,   171,   172,   173,    -1,    83,    84,   177,
      -1,    -1,   180,    -1,    -1,   183,    -1,    93,    -1,    -1,
      96,     5,    -1,    -1,   192,    -1,   194,   103,    -1,    -1,
      -1,    -1,   172,   173,   202,   203,    -1,   177,    -1,    -1,
     116,   117,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    -1,   194,    -1,    -1,    41,    -1,    43,
      -1,    -1,    -1,   203,    48,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,   171,   172,   173,    -1,    83,
      84,   177,    -1,     5,    -1,    89,    -1,   183,    -1,    93,
      -1,    -1,    96,    -1,    -1,    -1,   192,    -1,   194,   103,
      -1,    -1,    -1,    -1,    -1,    -1,   202,   203,    -1,    -1,
     114,    -1,   116,   117,   118,   119,    -1,    -1,    -1,    41,
      -1,    43,   126,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
     164,    83,    84,    -1,    -1,    -1,    -1,   171,   172,   173,
      -1,    93,    -1,   177,    96,    -1,   180,    -1,    -1,   183,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,
     194,    -1,    -1,    -1,   116,   117,   118,   119,   202,   203,
      -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,
     172,   173,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,
      -1,   183,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,
     192,    34,   194,    36,    37,    38,    39,    40,    -1,    42,
     202,   203,    45,    -1,    47,    -1,    -1,    50,    51,    52,
      -1,    54,    55,    56,    57,    58,    59,    -1,    61,    -1,
      63,    64,    65,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    -1,    -1,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    87,    88,    -1,    -1,    91,    92,
      -1,    94,    95,    -1,    97,    98,    99,   100,   101,   102,
      -1,   104,   105,   106,   107,   108,   109,    -1,    -1,   112,
      -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,   121,   122,
      -1,   124,   125,    -1,   127,   128,   129,    -1,    -1,    -1,
      -1,   134,   135,   136,    -1,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
      -1,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,    -1,   168,   169,    -1,    -1,    -1,
      -1,    -1,   175,    -1,    -1,   178,    -1,   180,   181,   182,
      -1,    -1,   185,   186,   187,   188,    -1,    -1,   191,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   240,   246,     0,     3,     4,     5,    18,    35,    41,
      43,    48,    49,    53,    60,    62,    74,    77,    83,    84,
      89,    93,    96,   103,   110,   114,   116,   117,   118,   119,
     120,   126,   133,   151,   164,   170,   171,   172,   173,   177,
     180,   183,   192,   194,   202,   203,   231,   241,   243,   252,
     253,   255,   256,   257,   258,   261,   262,   268,   269,   288,
     302,   305,   307,   309,   310,   311,   312,   315,   316,   317,
     318,   319,   320,   321,   324,   325,   328,   332,   335,   340,
     345,   346,   347,   348,   350,   353,   371,   372,   373,   374,
     375,   230,   231,   377,   380,   381,     3,     5,   305,   305,
     236,   234,   305,     3,   304,   305,   116,   308,     9,   305,
     308,     3,   236,   305,   236,   308,   309,     3,   304,     3,
     304,   309,    29,    30,    34,    36,    37,    38,    39,    40,
      42,    45,    47,    50,    51,    52,    54,    55,    56,    57,
      58,    59,    61,    63,    64,    65,    67,    68,    69,    70,
      71,    72,    73,    75,    78,    79,    80,    81,    82,    85,
      86,    87,    88,    91,    92,    94,    95,    97,    98,    99,
     100,   101,   102,   104,   105,   106,   107,   108,   109,   112,
     115,   121,   122,   124,   125,   127,   128,   129,   134,   135,
     136,   138,   139,   140,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   152,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   165,   166,   168,   169,   175,   178,
     180,   181,   182,   185,   186,   187,   188,   191,   193,   195,
     196,   197,   198,   199,   200,   201,   204,   270,   280,   370,
     233,   248,   248,    66,   131,   190,   344,    83,   123,   183,
     192,   260,   288,   315,   317,   319,   332,   350,   371,   375,
     233,     3,   305,   216,   233,   233,   233,   230,   234,   233,
     324,   233,   251,   233,   352,   353,   352,   352,    12,    13,
      14,    15,   220,   236,   281,   305,   306,   354,   355,   368,
     288,   371,   373,   375,   352,   233,    33,    63,    80,    88,
     382,   383,   377,   120,     9,   242,   234,   233,   216,     3,
      64,   373,   234,   184,   234,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   210,   232,
      17,    62,   111,   245,   252,   259,   262,   315,   316,   317,
     318,   319,   320,   321,   324,   332,   335,   340,   345,   235,
     373,   305,   268,   269,   234,     3,   305,     3,     3,   234,
     234,   212,   329,   234,   341,   368,   230,   307,   310,   311,
     312,   313,   314,     3,   247,   234,   349,   354,   354,   238,
     231,   236,   267,   352,   236,   210,   232,     5,   237,   120,
     235,   268,   284,   285,   286,   287,   333,   212,   212,   237,
     295,   236,   298,   274,   276,   350,     9,    16,   306,     3,
       6,     7,     8,     9,    10,    11,    90,   141,   176,   189,
     215,   218,   219,   220,   223,   224,   236,   291,   292,   293,
     278,   350,   274,   350,     6,   273,    16,   291,   294,     9,
     279,     9,     9,   271,   294,   350,   293,     9,     9,   293,
       9,   293,   291,   266,   269,   350,   293,   289,   290,   291,
      31,   137,   179,   272,     9,     9,   370,     9,   293,   373,
     289,   275,   350,   291,   373,   132,   205,   206,   207,   208,
     209,   369,   373,   373,    16,     6,     7,   376,     9,   373,
     280,   231,   234,   236,   233,   233,   233,   234,   233,   233,
     251,   306,   350,   250,   322,   311,   312,   234,   235,   329,
     305,   220,   220,   210,   217,   246,   153,   326,   332,   348,
     354,   237,   294,   220,   232,   291,   263,   264,   265,   266,
      32,    76,   174,   208,   384,   385,   383,   234,   311,   306,
     235,   210,   238,   305,   330,   331,     6,   254,   254,   235,
     268,   296,   268,   300,   235,   269,   297,   300,   237,   210,
     237,   237,   237,   236,   291,   291,   291,   291,   291,   291,
       5,   291,   351,   353,   372,    19,    20,    21,    22,    23,
      24,    25,    26,    27,   211,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   230,   231,   210,   237,   237,
     210,   237,   210,   230,   237,   210,   237,   210,   237,   237,
     210,   237,   237,   237,   237,   237,   237,   237,   237,   237,
     237,   237,   350,   220,   236,   267,   281,   306,   360,   362,
     363,   237,   210,   237,   237,   237,   237,   237,   237,   210,
     237,   237,   237,   210,   237,   237,   237,   237,   237,   237,
     230,   237,   237,   237,   280,   244,     9,   249,   216,   236,
     354,   364,   235,   252,   268,   269,   235,   268,   323,   322,
     251,   167,   339,   313,   235,   212,   130,   300,   327,   233,
     232,   232,   237,   210,   210,   237,   190,   378,   379,   216,
     287,   293,   210,   334,     6,   237,   237,   350,   375,   350,
     371,   237,   233,   233,   273,   274,   351,   237,   220,   236,
     267,   281,   356,   358,   359,   372,   352,   291,   291,     3,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,     3,   291,   293,
     157,   160,   277,     6,   294,     3,     9,   362,   349,   220,
     263,   281,   361,   362,   236,   267,   290,   293,   274,     6,
     120,   235,   237,   248,   336,   263,   210,   251,   251,    74,
     120,   342,   343,   235,   311,   312,   338,   234,   212,   233,
     235,   269,   301,   302,   235,    28,   266,   385,   381,   235,
     378,   314,   330,   217,   360,   366,   367,   233,   354,   303,
     306,   358,   349,   220,   263,   281,   357,   358,   237,   236,
     267,   352,   212,   232,   210,   237,   210,   362,   349,   237,
     362,   237,   263,   237,   311,   251,   235,   331,   237,   354,
     305,   305,   310,   312,   233,   233,   251,   210,   250,   233,
       5,   217,   212,   365,   210,   233,   234,   237,   358,   349,
     237,   362,   237,   291,   263,   291,   274,   274,   362,   237,
     216,   217,   251,   305,   311,   312,   235,   233,   233,   294,
     366,   282,   362,   237,   314,   236,   251,    47,    64,   235,
     283,   217,   263,   293,   212,   233,   237,   212,   233,   299,
     300,   337,   299,   233,   251
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   239,   240,   241,   241,   242,   242,   243,   244,   244,
     245,   246,   247,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   248,   248,
     248,   249,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   250,   250,   251,   251,
     252,   252,   252,   252,   252,   252,   252,   253,   253,   254,
     254,   255,   255,   255,   255,   255,   255,   255,   255,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   263,   264,
     264,   265,   265,   266,   266,   267,   267,   267,   268,   268,
     269,   270,   270,   270,   271,   271,   272,   272,   272,   273,
     273,   274,   275,   276,   276,   277,   277,   278,   279,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   281,   281,   281,   281,   282,   282,
     283,   283,   284,   284,   284,   285,   285,   286,   287,   287,
     288,   289,   289,   290,   290,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   292,   292,   293,   294,
     295,   295,   296,   296,   297,   297,   298,   298,   299,   299,
     300,   300,   301,   302,   302,   303,   303,   304,   304,   305,
     305,   306,   307,   307,   307,   307,   307,   307,   307,   307,
     307,   307,   307,   308,   308,   309,   309,   309,   309,   309,
     309,   309,   309,   309,   310,   310,   311,   311,   312,   313,
     313,   313,   313,   313,   314,   314,   315,   316,   317,   318,
     319,   320,   321,   321,   322,   322,   323,   323,   324,   325,
     326,   326,   327,   327,   328,   328,   329,   329,   329,   330,
     331,   331,   332,   333,   334,   332,   335,   336,   337,   335,
     338,   338,   338,   338,   339,   339,   341,   340,   340,   342,
     342,   342,   343,   344,   345,   346,   346,   346,   347,   348,
     349,   349,   350,   350,   351,   351,   352,   352,   353,   353,
     353,   354,   354,   354,   355,   355,   355,   355,   356,   356,
     356,   357,   357,   358,   358,   359,   359,   359,   359,   359,
     360,   360,   360,   361,   361,   362,   362,   363,   363,   363,
     363,   363,   363,   364,   364,   365,   365,   366,   367,   367,
     368,   368,   369,   369,   369,   369,   369,   369,   370,   370,
     370,   371,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   373,   373,   373,   374,   375,   375,   376,   376,
     376,   377,   377,   378,   378,   379,   380,   381,   381,   382,
     382,   383,   383,   383,   383,   384,   384,   385,   385,   385,
     385
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     7,     4,     0,     7,
       4,     0,     0,     6,     3,     3,     2,     2,     3,     2,
       3,     2,     3,     2,     2,     2,     2,     2,     0,     3,
       3,     0,     6,     2,     2,     3,     2,     3,     2,     3,
       2,     2,     2,     2,     2,     2,     0,     2,     0,     1,
       1,     2,     2,     1,     2,     1,     1,     6,     6,     1,
       2,     1,     2,     1,     2,     1,     2,     2,     2,     2,
       4,     3,     3,     5,     2,     3,     4,     0,     1,     1,
       3,     1,     3,     3,     2,     3,     3,     2,     0,     1,
       3,     1,     3,     4,     1,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     1,     1,     1,     5,     5,     0,
       4,     1,     4,     1,     1,     1,     1,     1,     4,     4,
       1,     4,     1,     1,     1,     1,     4,     4,     1,     6,
       1,     1,     1,     1,     1,     4,     1,     4,     1,     1,
       4,     1,     1,     1,     4,     4,     1,     1,     4,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     1,
       4,     1,     1,     4,     1,     4,     1,     1,     4,     4,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     1,     4,     1,
       4,     4,     1,     1,     1,     1,     1,     1,     6,     1,
       4,     1,     1,     1,     4,     1,     4,     1,     1,     4,
       4,     4,     4,     1,     1,     4,     4,     4,     1,     1,
       4,     4,     4,     1,     1,     1,     1,     1,     0,     2,
       4,     3,     0,     2,     1,     1,     3,     2,     3,     1,
       5,     1,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     2,     2,     2,     2,
       3,     3,     5,     5,     4,     3,     1,     3,     1,     1,
       0,     2,     4,     3,     2,     2,     0,     2,     2,     1,
       3,     2,     1,     3,     2,     0,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     2,     1,     2,     2,
       1,     1,     1,     1,     2,     3,     1,     2,     4,     1,
       1,     2,     1,     2,     1,     3,     2,     6,     2,     7,
       2,     5,     2,     3,     0,     2,     3,     3,     2,     1,
       2,     3,     2,     3,     6,     6,     0,     2,     2,     1,
       1,     3,     2,     0,     0,     7,     8,     0,     0,    13,
       1,     1,     3,     3,     0,     2,     0,     9,     2,     2,
       3,     2,     2,     2,     6,     1,     1,     1,     1,     1,
       0,     2,     2,     3,     2,     3,     0,     1,     2,     2,
       2,     3,     2,     1,     1,     3,     2,     4,     3,     2,
       1,     3,     2,     0,     1,     3,     2,     1,     3,     4,
       3,     2,     1,     3,     2,     0,     1,     1,     3,     2,
       1,     3,     4,     1,     3,     0,     2,     2,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     1,     1,     1,     2,     1,     2,     1,     2,
       4,     1,     1,     2,     1,     5,     5,    10,     1,     3,
       1,     0,     2,     0,     2,     4,     6,     0,     3,     1,
       3,     4,     1,     1,     1,     1,     3,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if PARSER_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined PARSER_LTYPE_IS_TRIVIAL && PARSER_LTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !PARSER_DEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !PARSER_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined PARSER_LTYPE_IS_TRIVIAL && PARSER_LTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 369 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyvsp[-1].stmt_list) = append_parameterized_type_stmts((yyvsp[-1].stmt_list));
						  check_statements((yyvsp[-1].stmt_list), FALSE);
						  check_all_user_types((yyvsp[-1].stmt_list));
						  write_header((yyvsp[-1].stmt_list));
						  write_id_data((yyvsp[-1].stmt_list));
						  write_proxies((yyvsp[-1].stmt_list));
						  write_client((yyvsp[-1].stmt_list));
						  write_server((yyvsp[-1].stmt_list));
						  write_regscript((yyvsp[-1].stmt_list));
						  write_typelib_regscript((yyvsp[-1].stmt_list));
						  write_dlldata((yyvsp[-1].stmt_list));
						  write_local_stubs((yyvsp[-1].stmt_list));
						}
#line 3034 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 390 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 3040 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 392 "tools/widl/parser.y" /* yacc.c:1646  */
    { parameterized_type_stmts = append_statement(parameterized_type_stmts, make_statement_parameterized_type((yyvsp[-4].type), (yyvsp[-2].typeref_list)));
						  (yyval.stmt_list) = append_statement((yyvsp[-6].stmt_list), make_statement_reference(type_parameterized_type_specialize_declare((yyvsp[-4].type), (yyvsp[-2].typeref_list))));
						}
#line 3048 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 397 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-1].stmt_list); }
#line 3054 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 401 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 3060 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 403 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-6].stmt_list), make_statement_reference(type_parameterized_type_specialize_declare((yyvsp[-4].type), (yyvsp[-2].typeref_list)))); }
#line 3066 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 407 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-1].stmt_list); }
#line 3072 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 411 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 3078 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 412 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_namespaces((yyvsp[-1].str_list)); }
#line 3084 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 413 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_namespaces((yyvsp[-4].str_list)); (yyval.stmt_list) = append_statements((yyvsp[-5].stmt_list), (yyvsp[-1].stmt_list)); }
#line 3090 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 414 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 3096 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 415 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 3102 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 416 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3108 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 417 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3114 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 418 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list);
						  reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0);
						}
#line 3122 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 421 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0);
						}
#line 3130 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 424 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3136 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 425 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 3143 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 427 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3149 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 428 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
	                                          reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 3156 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 430 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_module((yyvsp[0].type))); }
#line 3162 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 431 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_library((yyvsp[0].typelib))); }
#line 3168 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 432 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3174 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 433 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statements((yyvsp[-1].stmt_list), (yyvsp[0].stmt_list)); }
#line 3180 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 437 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 3186 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 438 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 3192 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 439 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 3198 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 440 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_namespaces((yyvsp[-1].str_list)); }
#line 3204 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 441 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_namespaces((yyvsp[-4].str_list)); (yyval.stmt_list) = append_statements((yyvsp[-5].stmt_list), (yyvsp[-1].stmt_list)); }
#line 3210 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 442 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3216 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 443 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3222 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 444 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3228 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 445 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0);
						}
#line 3236 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 448 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3242 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 449 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 3249 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 451 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3255 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 452 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
	                                          reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 3262 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 454 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_module((yyvsp[0].type))); }
#line 3268 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 455 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3274 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 456 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_importlib((yyvsp[0].str))); }
#line 3280 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 457 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_library((yyvsp[0].typelib))); }
#line 3286 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 458 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statements((yyvsp[-1].stmt_list), (yyvsp[0].stmt_list)); }
#line 3292 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 462 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 3298 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 463 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3304 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 472 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_cppquote((yyvsp[0].str)); }
#line 3310 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 473 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_type_decl((yyvsp[-1].type)); }
#line 3316 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 474 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_declaration((yyvsp[-1].var)); }
#line 3322 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 475 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_import((yyvsp[0].str)); }
#line 3328 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 476 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 3334 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 477 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_pragma((yyvsp[0].str)); }
#line 3340 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 478 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = NULL; }
#line 3346 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 482 "tools/widl/parser.y" /* yacc.c:1646  */
    {
                      int result;
                      (yyval.statement) = NULL;
                      result = do_warning((yyvsp[-3].str), (yyvsp[-1].warning_list));
                      if(!result)
                          error_loc("expected \"disable\", \"enable\" or \"default\"\n");
                  }
#line 3358 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 490 "tools/widl/parser.y" /* yacc.c:1646  */
    {
                      (yyval.statement) = NULL;
                      do_warning("default", (yyvsp[-1].warning_list));
                  }
#line 3367 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 497 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.warning_list) = append_warning(NULL, (yyvsp[0].num)); }
#line 3373 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 498 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.warning_list) = append_warning((yyvsp[-1].warning_list), (yyvsp[0].num)); }
#line 3379 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 503 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_enum((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3385 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 505 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_struct((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3391 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 507 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3397 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 508 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_enum_attrs((yyvsp[-1].attr_list)); }
#line 3403 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 509 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_struct_attrs((yyvsp[-1].attr_list)); }
#line 3409 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 510 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_union_attrs((yyvsp[-1].attr_list)); }
#line 3415 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 513 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-1].str); }
#line 3421 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 516 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-1].str); push_import( (yyvsp[-1].str), &yylloc ); }
#line 3427 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 518 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_import( &yylloc ); }
#line 3433 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 522 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-2].str); if(!parse_only) add_importlib((yyvsp[-2].str), current_typelib); }
#line 3439 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 525 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 3445 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 527 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typelib) = make_library((yyvsp[-1].str), check_library_attrs((yyvsp[-1].str), (yyvsp[-2].attr_list)));
						  if (!parse_only && do_typelib) current_typelib = (yyval.typelib);
						}
#line 3453 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 532 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typelib) = (yyvsp[-3].typelib); (yyval.typelib)->stmts = (yyvsp[-2].stmt_list); }
#line 3459 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 536 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 3465 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 540 "tools/widl/parser.y" /* yacc.c:1646  */
    { check_arg_attrs((yyvsp[0].var)); (yyval.var_list) = append_var( NULL, (yyvsp[0].var) ); }
#line 3471 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 541 "tools/widl/parser.y" /* yacc.c:1646  */
    { check_arg_attrs((yyvsp[0].var)); (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[0].var) ); }
#line 3477 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 545 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-2].var_list), make_var(xstrdup("...")) ); }
#line 3483 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 549 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].declspec)->stgclass != STG_NONE && (yyvsp[-1].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var((yyvsp[-2].attr_list), (yyvsp[-1].declspec), (yyvsp[0].declarator), TRUE);
						  free((yyvsp[-1].declspec)); free((yyvsp[0].declarator));
						}
#line 3493 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 554 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].declspec)->stgclass != STG_NONE && (yyvsp[-1].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var(NULL, (yyvsp[-1].declspec), (yyvsp[0].declarator), TRUE);
						  free((yyvsp[-1].declspec)); free((yyvsp[0].declarator));
						}
#line 3503 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 561 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr);
						  if (!(yyval.expr)->is_const || (yyval.expr)->cval <= 0)
						      error_loc("array dimension is not a positive integer constant\n");
						}
#line 3512 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 565 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr(EXPR_VOID); }
#line 3518 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 566 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr(EXPR_VOID); }
#line 3524 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 570 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = NULL; }
#line 3530 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 575 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = (yyvsp[-1].attr_list); }
#line 3536 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 578 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( NULL, (yyvsp[0].attr) ); }
#line 3542 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 579 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( (yyvsp[-2].attr_list), (yyvsp[0].attr) ); }
#line 3548 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 580 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( (yyvsp[-3].attr_list), (yyvsp[0].attr) ); }
#line 3554 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 583 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str_list) = append_str( NULL, (yyvsp[0].str) ); }
#line 3560 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 584 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str_list) = append_str( (yyvsp[-2].str_list), (yyvsp[0].str) ); }
#line 3566 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 588 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MARSHALING_AGILE; }
#line 3572 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 589 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MARSHALING_NONE; }
#line 3578 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 590 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MARSHALING_STANDARD; }
#line 3584 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 594 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION(0, (yyvsp[0].num)); }
#line 3590 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 595 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION((yyvsp[0].num), (yyvsp[-2].num)); }
#line 3596 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 599 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].declspec)->type->type_type != TYPE_APICONTRACT)
						      error_loc("type %s is not an apicontract\n", (yyvsp[-2].declspec)->type->name);
						  (yyval.expr) = make_exprl(EXPR_NUM, (yyvsp[0].num));
						  (yyval.expr) = make_exprt(EXPR_GTREQL, declare_var(NULL, (yyvsp[-2].declspec), make_declarator(NULL), 0), (yyval.expr));
						}
#line 3606 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 607 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].declspec)->type->type_type != TYPE_INTERFACE)
						      error_loc("type %s is not an interface\n", (yyvsp[-2].declspec)->type->name);
						  (yyval.expr) = make_exprt(EXPR_MEMBER, declare_var(NULL, (yyvsp[-2].declspec), make_declarator(NULL), 0), (yyvsp[0].expr));
						}
#line 3615 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 614 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].declspec)->type->type_type != TYPE_INTERFACE)
						      error_loc("type %s is not an interface\n", (yyvsp[-2].declspec)->type->name);
						  (yyval.expr) = make_exprt(EXPR_MEMBER, declare_var(NULL, (yyvsp[-2].declspec), make_declarator(NULL), 0), (yyvsp[0].expr));
						}
#line 3624 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 618 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 3630 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 622 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PUBLIC, 0 ); }
#line 3636 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 623 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PROTECTED, 0 ); }
#line 3642 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 628 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-4].declspec)->type->type_type != TYPE_INTERFACE)
                                                      error_loc( "type %s is not an interface\n", (yyvsp[-4].declspec)->type->name );
                                                  (yyval.expr) = make_exprt( EXPR_MEMBER, declare_var( append_attr( NULL, (yyvsp[-2].attr) ), (yyvsp[-4].declspec), make_declarator( NULL ), 0 ), (yyvsp[0].expr) );
                                                }
#line 3651 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 636 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr3( EXPR_MEMBER, make_exprs( EXPR_STRLIT, (yyvsp[-4].str) ), make_exprs( EXPR_IDENTIFIER, (yyvsp[-2].str) ), (yyvsp[0].expr) ); }
#line 3657 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 640 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = NULL; }
#line 3663 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 641 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_ACTIVATABLE, (yyvsp[-1].expr) ); }
#line 3669 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 642 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_AGGREGATABLE, 0 ); }
#line 3675 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 643 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_ANNOTATION, (yyvsp[-1].str) ); }
#line 3681 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 644 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_APPOBJECT, 0 ); }
#line 3687 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 645 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_ASYNC, 0 ); }
#line 3693 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 646 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_AUTO_HANDLE, 0 ); }
#line 3699 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 647 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_BINDABLE, 0 ); }
#line 3705 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 648 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_BROADCAST, 0 ); }
#line 3711 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 649 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_CALLAS, (yyvsp[-1].var) ); }
#line 3717 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 650 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_CASE, (yyvsp[-1].expr_list) ); }
#line 3723 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 651 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_CODE, 0 ); }
#line 3729 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 652 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_COMPOSABLE, (yyvsp[-1].expr) ); }
#line 3735 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 653 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_COMMSTATUS, 0 ); }
#line 3741 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 654 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_CONTEXTHANDLE, 0 ); }
#line 3747 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 655 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_CONTEXTHANDLE, 0 ); /* RPC_CONTEXT_HANDLE_DONT_SERIALIZE */ }
#line 3753 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 656 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_CONTEXTHANDLE, 0 ); /* RPC_CONTEXT_HANDLE_SERIALIZE */ }
#line 3759 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 657 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_CONTRACT, (yyvsp[-1].expr) ); }
#line 3765 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 658 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_CONTRACTVERSION, (yyvsp[-1].num) ); }
#line 3771 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 659 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_CONTROL, 0 ); }
#line 3777 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 660 "tools/widl/parser.y" /* yacc.c:1646  */
    { attr_custdata_t *data = xmalloc( sizeof(*data) );
                                                  data->id = *(yyvsp[-3].uuid); data->pval = (yyvsp[-1].expr);
                                                  (yyval.attr) = attr_ptr( (yyloc), ATTR_CUSTOM, data );
                                                }
#line 3786 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 664 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DECODE, 0 ); }
#line 3792 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 665 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DEFAULT, 0 ); }
#line 3798 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 666 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DEFAULT_OVERLOAD, 0 ); }
#line 3804 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 667 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DEFAULTBIND, 0 ); }
#line 3810 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 668 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DEFAULTCOLLELEM, 0 ); }
#line 3816 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 669 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_DEFAULTVALUE, (yyvsp[-1].expr) ); }
#line 3822 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 670 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DEFAULTVTABLE, 0 ); }
#line 3828 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 671 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_DEPRECATED, (yyvsp[-1].expr) ); }
#line 3834 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 672 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DISABLECONSISTENCYCHECK, 0 ); }
#line 3840 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 673 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DISPLAYBIND, 0 ); }
#line 3846 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 674 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_DLLNAME, (yyvsp[-1].str) ); }
#line 3852 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 675 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DUAL, 0 ); }
#line 3858 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 676 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_ENABLEALLOCATE, 0 ); }
#line 3864 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 677 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_ENCODE, 0 ); }
#line 3870 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 678 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_ENDPOINT, (yyvsp[-1].str_list) ); }
#line 3876 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 679 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_ENTRY, (yyvsp[-1].expr) ); }
#line 3882 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 680 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_EVENTADD, 0 ); }
#line 3888 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 681 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_EVENTREMOVE, 0 ); }
#line 3894 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 682 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].declspec)->type->type_type != TYPE_RUNTIMECLASS)
                                                      error_loc( "type %s is not a runtimeclass\n", (yyvsp[-1].declspec)->type->name );
                                                  (yyval.attr) = attr_ptr( (yyloc), ATTR_EXCLUSIVETO, (yyvsp[-1].declspec)->type );
                                                }
#line 3903 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 686 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_EXPLICIT_HANDLE, 0 ); }
#line 3909 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 687 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_FAULTSTATUS, 0 ); }
#line 3915 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 688 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_FLAGS, 0 ); }
#line 3921 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 689 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_FORCEALLOCATE, 0 ); }
#line 3927 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 690 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_HANDLE, 0 ); }
#line 3933 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 691 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_HELPCONTEXT, (yyvsp[-1].expr) ); }
#line 3939 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 692 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_HELPFILE, (yyvsp[-1].str) ); }
#line 3945 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 693 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_HELPSTRING, (yyvsp[-1].str) ); }
#line 3951 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 695 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_HELPSTRINGCONTEXT, (yyvsp[-1].expr) ); }
#line 3957 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 696 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_HELPSTRINGDLL, (yyvsp[-1].str) ); }
#line 3963 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 697 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_HIDDEN, 0 ); }
#line 3969 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 698 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_ID, (yyvsp[-1].expr) ); }
#line 3975 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 699 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_IDEMPOTENT, 0 ); }
#line 3981 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 700 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_IGNORE, 0 ); }
#line 3987 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 701 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_IIDIS, (yyvsp[-1].expr) ); }
#line 3993 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 702 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_IMMEDIATEBIND, 0 ); }
#line 3999 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 703 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_IMPLICIT_HANDLE, (yyvsp[-1].var) ); }
#line 4005 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 704 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_IN, 0 ); }
#line 4011 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 705 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_INPUTSYNC, 0 ); }
#line 4017 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 706 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_LENGTHIS, (yyvsp[-1].expr_list) ); }
#line 4023 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 707 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_LIBLCID, (yyvsp[-1].expr) ); }
#line 4029 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 708 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PARAMLCID, 0 ); }
#line 4035 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 709 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_LICENSED, 0 ); }
#line 4041 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 710 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_LOCAL, 0 ); }
#line 4047 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 712 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_MARSHALING_BEHAVIOR, (yyvsp[-1].num) ); }
#line 4053 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 713 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_MAYBE, 0 ); }
#line 4059 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 714 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_MESSAGE, 0 ); }
#line 4065 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 715 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_NOCODE, 0 ); }
#line 4071 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 716 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_NONBROWSABLE, 0 ); }
#line 4077 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 717 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_NONCREATABLE, 0 ); }
#line 4083 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 718 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_NONEXTENSIBLE, 0 ); }
#line 4089 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 719 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_NOTIFY, 0 ); }
#line 4095 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 720 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_NOTIFYFLAG, 0 ); }
#line 4101 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 721 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_OBJECT, 0 ); }
#line 4107 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 722 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_ODL, 0 ); }
#line 4113 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 723 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_OLEAUTOMATION, 0 ); }
#line 4119 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 724 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_OPTIMIZE, (yyvsp[-1].str) ); }
#line 4125 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 725 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_OPTIONAL, 0 ); }
#line 4131 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 726 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_OUT, 0 ); }
#line 4137 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 727 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_OVERLOAD, (yyvsp[-1].str) ); }
#line 4143 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 728 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PARTIALIGNORE, 0 ); }
#line 4149 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 729 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_POINTERDEFAULT, (yyvsp[-1].num) ); }
#line 4155 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 730 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_PROGID, (yyvsp[-1].str) ); }
#line 4161 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 731 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PROPGET, 0 ); }
#line 4167 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 732 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PROPPUT, 0 ); }
#line 4173 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 733 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PROPPUTREF, 0 ); }
#line 4179 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 734 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PROTECTED, 0 ); }
#line 4185 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 735 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PROXY, 0 ); }
#line 4191 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 736 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_PUBLIC, 0 ); }
#line 4197 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 738 "tools/widl/parser.y" /* yacc.c:1646  */
    { expr_list_t *list = append_expr( NULL, (yyvsp[-3].expr) );
                                                  list = append_expr( list, (yyvsp[-1].expr) );
                                                  (yyval.attr) = attr_ptr( (yyloc), ATTR_RANGE, list );
                                                }
#line 4206 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 742 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_READONLY, 0 ); }
#line 4212 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 743 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_REPRESENTAS, (yyvsp[-1].type) ); }
#line 4218 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 744 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_REQUESTEDIT, 0 ); }
#line 4224 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 745 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_RESTRICTED, 0 ); }
#line 4230 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 746 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_RETVAL, 0 ); }
#line 4236 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 747 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_SIZEIS, (yyvsp[-1].expr_list) ); }
#line 4242 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 748 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_SOURCE, 0 ); }
#line 4248 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 749 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_STATIC, (yyvsp[-1].expr) ); }
#line 4254 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 750 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_STRICTCONTEXTHANDLE, 0 ); }
#line 4260 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 751 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_STRING, 0 ); }
#line 4266 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 752 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_SWITCHIS, (yyvsp[-1].expr) ); }
#line 4272 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 753 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_SWITCHTYPE, (yyvsp[-1].type) ); }
#line 4278 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 754 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_TRANSMITAS, (yyvsp[-1].type) ); }
#line 4284 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 755 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_THREADING, (yyvsp[-1].num) ); }
#line 4290 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 756 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_UIDEFAULT, 0 ); }
#line 4296 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 757 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_USESGETLASTERROR, 0 ); }
#line 4302 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 758 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_USERMARSHAL, (yyvsp[-1].type) ); }
#line 4308 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 759 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_UUID, (yyvsp[-1].uuid) ); }
#line 4314 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 760 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_ASYNCUUID, (yyvsp[-1].uuid) ); }
#line 4320 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 761 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_V1ENUM, 0 ); }
#line 4326 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 762 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_VARARG, 0 ); }
#line 4332 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 763 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_VERSION, (yyvsp[-1].num) ); }
#line 4338 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 764 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_VIPROGID, (yyvsp[-1].str) ); }
#line 4344 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 765 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_ptr( (yyloc), ATTR_WIREMARSHAL, (yyvsp[-1].type) ); }
#line 4350 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 766 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_POINTERTYPE, (yyvsp[0].num) ); }
#line 4356 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 776 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4362 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 777 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-1].var_list), (yyvsp[0].var) ); }
#line 4368 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 780 "tools/widl/parser.y" /* yacc.c:1646  */
    { attr_t *a = attr_ptr( (yyloc), ATTR_CASE, append_expr( NULL, (yyvsp[-2].expr) ) );
                                                  (yyval.var) = (yyvsp[0].var); if (!(yyval.var)) (yyval.var) = make_var( NULL );
                                                  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
                                                }
#line 4377 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 784 "tools/widl/parser.y" /* yacc.c:1646  */
    { attr_t *a = attr_int( (yyloc), ATTR_DEFAULT, 0 );
                                                  (yyval.var) = (yyvsp[0].var); if (!(yyval.var)) (yyval.var) = make_var( NULL );
                                                  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
                                                }
#line 4386 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 791 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4392 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 792 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = (yyvsp[-1].var_list); }
#line 4398 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 796 "tools/widl/parser.y" /* yacc.c:1646  */
    { if (!(yyvsp[0].var)->eval)
						    (yyvsp[0].var)->eval = make_exprl(EXPR_NUM, 0 /* default for first enum entry */);
                                                  (yyval.var_list) = append_var( NULL, (yyvsp[0].var) );
						}
#line 4407 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 800 "tools/widl/parser.y" /* yacc.c:1646  */
    { if (!(yyvsp[0].var)->eval)
                                                  {
                                                    var_t *last = LIST_ENTRY( list_tail((yyval.var_list)), var_t, entry );
                                                    enum expr_type type = EXPR_NUM;
                                                    if (last->eval->type == EXPR_HEXNUM) type = EXPR_HEXNUM;
                                                    if (last->eval->cval + 1 < 0) type = EXPR_HEXNUM;
                                                    (yyvsp[0].var)->eval = make_exprl(type, last->eval->cval + 1);
                                                  }
                                                  (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[0].var) );
						}
#line 4422 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 812 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[0].var);
						  (yyval.var)->attrs = check_enum_member_attrs((yyvsp[-1].attr_list));
						}
#line 4430 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 817 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = reg_const((yyvsp[-2].var));
						  (yyval.var)->eval = (yyvsp[0].expr);
                                                  (yyval.var)->declspec.type = type_new_int(TYPE_BASIC_INT, 0);
						}
#line 4439 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 821 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = reg_const((yyvsp[0].var));
                                                  (yyval.var)->declspec.type = type_new_int(TYPE_BASIC_INT, 0);
						}
#line 4447 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 826 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_enum((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 4453 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 829 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( NULL, (yyvsp[0].expr) ); }
#line 4459 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 830 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( (yyvsp[-2].expr_list), (yyvsp[0].expr) ); }
#line 4465 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 834 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr(EXPR_VOID); }
#line 4471 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 838 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_NUM, (yyvsp[0].num)); }
#line 4477 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 839 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_HEXNUM, (yyvsp[0].num)); }
#line 4483 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 840 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprd(EXPR_DOUBLE, (yyvsp[0].dbl)); }
#line 4489 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 841 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 0); }
#line 4495 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 842 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_NUM, 0); }
#line 4501 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 843 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 1); }
#line 4507 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 844 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_STRLIT, (yyvsp[0].str)); }
#line 4513 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 845 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_WSTRLIT, (yyvsp[0].str)); }
#line 4519 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 846 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_CHARCONST, (yyvsp[0].str)); }
#line 4525 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 847 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str)); }
#line 4531 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 848 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr3(EXPR_COND, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4537 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 849 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LOGOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4543 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 850 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LOGAND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4549 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 851 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_OR , (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4555 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 852 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_XOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4561 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 853 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4567 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 854 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_EQUALITY, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4573 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 855 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_INEQUALITY, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4579 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 856 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_GTR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4585 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 857 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LESS, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4591 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 858 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_GTREQL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4597 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 859 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LESSEQL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4603 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 860 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_SHL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4609 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 861 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_SHR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4615 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 862 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_ADD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4621 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 863 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_SUB, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4627 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 864 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MOD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4633 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 865 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MUL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4639 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 866 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_DIV, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4645 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 867 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_LOGNOT, (yyvsp[0].expr)); }
#line 4651 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 868 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_NOT, (yyvsp[0].expr)); }
#line 4657 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 869 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_POS, (yyvsp[0].expr)); }
#line 4663 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 870 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_NEG, (yyvsp[0].expr)); }
#line 4669 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 871 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_ADDRESSOF, (yyvsp[0].expr)); }
#line 4675 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 872 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_PPTR, (yyvsp[0].expr)); }
#line 4681 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 873 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MEMBER, make_expr1(EXPR_PPTR, (yyvsp[-2].expr)), make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str))); }
#line 4687 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 874 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MEMBER, (yyvsp[-2].expr), make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str))); }
#line 4693 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 876 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprt(EXPR_CAST, declare_var(NULL, (yyvsp[-3].declspec), (yyvsp[-2].declarator), 0), (yyvsp[0].expr)); free((yyvsp[-3].declspec)); free((yyvsp[-2].declarator)); }
#line 4699 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 878 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprt(EXPR_SIZEOF, declare_var(NULL, (yyvsp[-2].declspec), (yyvsp[-1].declarator), 0), NULL); free((yyvsp[-2].declspec)); free((yyvsp[-1].declarator)); }
#line 4705 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 879 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_ARRAY, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 4711 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 880 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4717 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 883 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( NULL, (yyvsp[0].expr) ); }
#line 4723 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 884 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( (yyvsp[-2].expr_list), (yyvsp[0].expr) ); }
#line 4729 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 887 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr);
						  if (!(yyval.expr)->is_const)
						      error_loc("expression is not an integer constant\n");
						}
#line 4738 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 893 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr);
						  if (!(yyval.expr)->is_const && (yyval.expr)->type != EXPR_STRLIT && (yyval.expr)->type != EXPR_WSTRLIT)
						      error_loc("expression is not constant\n");
						}
#line 4747 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 900 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4753 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 901 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var_list((yyvsp[-1].var_list), (yyvsp[0].var_list)); }
#line 4759 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 905 "tools/widl/parser.y" /* yacc.c:1646  */
    { const char *first = LIST_ENTRY(list_head((yyvsp[-1].declarator_list)), declarator_t, entry)->var->name;
						  check_field_attrs(first, (yyvsp[-3].attr_list));
						  (yyval.var_list) = set_var_types((yyvsp[-3].attr_list), (yyvsp[-2].declspec), (yyvsp[-1].declarator_list));
						}
#line 4768 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 909 "tools/widl/parser.y" /* yacc.c:1646  */
    { var_t *v = make_var(NULL);
						  v->declspec.type = (yyvsp[-1].type); v->attrs = (yyvsp[-2].attr_list);
						  (yyval.var_list) = append_var(NULL, v);
						}
#line 4777 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 916 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[-1].var); }
#line 4783 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 917 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = make_var(NULL); (yyval.var)->attrs = (yyvsp[-1].attr_list); }
#line 4789 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 921 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4795 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 922 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-1].var_list), (yyvsp[0].var) ); }
#line 4801 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 926 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[-1].var); }
#line 4807 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 927 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = NULL; }
#line 4813 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 930 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = declare_var(check_field_attrs((yyvsp[0].declarator)->var->name, (yyvsp[-2].attr_list)),
						                (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4822 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 934 "tools/widl/parser.y" /* yacc.c:1646  */
    { var_t *v = make_var(NULL);
						  v->declspec.type = (yyvsp[0].type); v->attrs = (yyvsp[-1].attr_list);
						  (yyval.var) = v;
						}
#line 4831 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 940 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[0].var);
						  if (type_get_type((yyval.var)->declspec.type) != TYPE_FUNCTION)
						    error_loc("only methods may be declared inside the methods section of a dispinterface\n");
						  check_function_attrs((yyval.var)->name, (yyval.var)->attrs);
						}
#line 4841 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 949 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = declare_var((yyvsp[-2].attr_list), (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4849 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 952 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = declare_var(NULL, (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4857 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 958 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = NULL; }
#line 4863 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 963 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4869 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 971 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = make_var((yyvsp[0].str)); }
#line 4875 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 974 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "byte" ); }
#line 4881 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 975 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "wchar_t" ); }
#line 4887 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 977 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[0].type)), -1); }
#line 4893 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 978 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[0].type)), 1); }
#line 4899 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 979 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT, 1); }
#line 4905 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 980 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "float" ); }
#line 4911 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 981 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "double" ); }
#line 4917 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 982 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "boolean" ); }
#line 4923 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 983 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "error_status_t" ); }
#line 4929 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 984 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error( NULL, "handle_t" ); }
#line 4935 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 992 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT, 0); }
#line 4941 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 993 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT16, 0); }
#line 4947 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 994 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT8, 0); }
#line 4953 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 995 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_LONG, 0); }
#line 4959 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 996 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_HYPER, 0); }
#line 4965 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 997 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT64, 0); }
#line 4971 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 998 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_CHAR, 0); }
#line 4977 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 999 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT32, 0); }
#line 4983 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1000 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT3264, 0); }
#line 4989 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1004 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.namespace) = find_namespace_or_error(&global_namespace, (yyvsp[-1].str)); }
#line 4995 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1005 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.namespace) = find_namespace_or_error((yyvsp[-2].namespace), (yyvsp[-1].str)); }
#line 5001 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1009 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(current_namespace, (yyvsp[0].str)); }
#line 5007 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1010 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error((yyvsp[-1].namespace), (yyvsp[0].str)); }
#line 5013 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1014 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_parameterized_type((yyvsp[-3].type), (yyvsp[-1].typeref_list)); }
#line 5019 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1018 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5025 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1019 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5031 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1020 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_pointer((yyvsp[-1].type)); }
#line 5037 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1021 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5043 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1022 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_pointer((yyvsp[-1].type)); }
#line 5049 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1026 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 5055 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1028 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 5061 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1031 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_coclass_declare((yyvsp[0].str)); }
#line 5067 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1035 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_coclass_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].typeref_list)); }
#line 5073 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1038 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_runtimeclass_declare((yyvsp[0].str), current_namespace); }
#line 5079 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1042 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-4].type) && type_get_type((yyvsp[-4].type)) != TYPE_RUNTIMECLASS) error_loc("%s is not a runtimeclass\n", (yyvsp[-4].type)->name);
						  (yyval.type) = type_runtimeclass_define((yyvsp[-5].type), (yyvsp[-6].attr_list), (yyvsp[-2].typeref_list)); }
#line 5086 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1046 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_apicontract_declare((yyvsp[0].str), current_namespace); }
#line 5092 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1050 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_apicontract_define((yyvsp[-3].type), (yyvsp[-4].attr_list)); }
#line 5098 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1053 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str_list) = append_str( NULL, (yyvsp[0].str) ); }
#line 5104 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1054 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str_list) = append_str( (yyvsp[-2].str_list), (yyvsp[0].str) ); }
#line 5110 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1058 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = NULL; }
#line 5116 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1059 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref( (yyvsp[-1].typeref_list), (yyvsp[0].typeref) ); }
#line 5122 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1063 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref) = make_typeref((yyvsp[-1].type)); (yyval.typeref)->attrs = (yyvsp[-2].attr_list); }
#line 5128 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1064 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref) = make_typeref((yyvsp[-1].type)); (yyval.typeref)->attrs = (yyvsp[-2].attr_list); }
#line 5134 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1067 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_dispinterface_declare((yyvsp[0].str)); }
#line 5140 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1070 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( (yyvsp[0].attr_list), attr_int( (yyloc), ATTR_DISPINTERFACE, 0 ) ); }
#line 5146 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1073 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 5152 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1074 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[-1].var) ); }
#line 5158 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1077 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 5164 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1078 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[-1].var) ); }
#line 5170 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1083 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_dispinterface_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].var_list), (yyvsp[-1].var_list)); }
#line 5176 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1085 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_dispinterface_define_from_iface((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].type)); }
#line 5182 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1089 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = NULL; }
#line 5188 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1090 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5194 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1091 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5200 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1094 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_PARAMETER, (yyvsp[0].str), parameters_namespace, 0); }
#line 5206 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1098 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 5212 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1099 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 5218 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1103 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_interface_declare((yyvsp[0].str), current_namespace); }
#line 5224 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1104 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_parameters_namespace((yyvsp[-1].str)); }
#line 5230 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1104 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_parameters_namespace((yyvsp[-3].str)); }
#line 5236 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1105 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_parameterized_interface_declare((yyvsp[-5].str), current_namespace, (yyvsp[-2].typeref_list)); }
#line 5242 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1109 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_delegate_declare((yyvsp[-4].var)->name, current_namespace);
						  (yyval.type) = type_delegate_define((yyval.type), (yyvsp[-7].attr_list), append_statement(NULL, make_statement_delegate((yyvsp[-5].type), (yyvsp[-2].var_list))));
						}
#line 5250 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1113 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_parameters_namespace((yyvsp[-1].var)->name); }
#line 5256 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1114 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_parameters_namespace((yyvsp[-7].var)->name); }
#line 5262 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1115 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_parameterized_delegate_declare((yyvsp[-9].var)->name, current_namespace, (yyvsp[-6].typeref_list));
						  (yyval.type) = type_parameterized_delegate_define((yyval.type), (yyvsp[-12].attr_list), append_statement(NULL, make_statement_delegate((yyvsp[-10].type), (yyvsp[-3].var_list))));
						}
#line 5270 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1121 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 5276 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1122 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 5282 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1123 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 5288 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1124 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 5294 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1128 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = NULL; }
#line 5300 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1129 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = (yyvsp[0].typeref_list); }
#line 5306 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1132 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[0].type)->type_type == TYPE_PARAMETERIZED_TYPE) push_parameters_namespace((yyvsp[0].type)->name); }
#line 5312 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1134 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-7].type)->type_type == TYPE_PARAMETERIZED_TYPE)
						  {
						      (yyval.type) = type_parameterized_interface_define((yyvsp[-7].type), (yyvsp[-8].attr_list), (yyvsp[-5].type), (yyvsp[-2].stmt_list), (yyvsp[-4].typeref_list));
						      pop_parameters_namespace((yyvsp[-7].type)->name);
						  }
						  else
						  {
						      (yyval.type) = type_interface_define((yyvsp[-7].type), (yyvsp[-8].attr_list), (yyvsp[-5].type), (yyvsp[-2].stmt_list), (yyvsp[-4].typeref_list));
						      check_async_uuid((yyval.type));
						  }
						}
#line 5328 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1145 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[-1].type); }
#line 5334 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1149 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 5340 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1150 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), (yyvsp[-1].namespace), 0); }
#line 5346 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1151 "tools/widl/parser.y" /* yacc.c:1646  */
    { if (type_get_type(((yyval.type) = (yyvsp[0].type))) != TYPE_INTERFACE) error_loc("%s is not an interface\n", (yyval.type)->name); }
#line 5352 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1155 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 5358 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1158 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_module_declare((yyvsp[0].str)); }
#line 5364 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1162 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_module_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].stmt_list)); }
#line 5370 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1166 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stgclass) = STG_EXTERN; }
#line 5376 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1167 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stgclass) = STG_STATIC; }
#line 5382 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1168 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stgclass) = STG_REGISTER; }
#line 5388 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1172 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.function_specifier) = FUNCTION_SPECIFIER_INLINE; }
#line 5394 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1176 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type_qualifier) = TYPE_QUALIFIER_CONST; }
#line 5400 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1180 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type_qualifier) = 0; }
#line 5406 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1181 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type_qualifier) = (yyvsp[-1].type_qualifier) | (yyvsp[0].type_qualifier); }
#line 5412 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1184 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[0].declspec), NULL, STG_NONE, 0, 0); }
#line 5418 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1186 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[-2].declspec), (yyvsp[0].declspec), STG_NONE, 0, 0); }
#line 5424 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1190 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[0].declspec), NULL, STG_NONE, 0, 0); }
#line 5430 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1192 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[-2].declspec), (yyvsp[0].declspec), STG_NONE, 0, 0); }
#line 5436 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1196 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = NULL; }
#line 5442 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1201 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, STG_NONE, (yyvsp[-1].type_qualifier), 0); }
#line 5448 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1202 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, STG_NONE, 0, (yyvsp[-1].function_specifier)); }
#line 5454 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1203 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, (yyvsp[-1].stgclass), 0, 0); }
#line 5460 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1208 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5466 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1209 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv( (yyloc), (yyval.declarator)->type, (yyvsp[-1].str) ); }
#line 5472 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1214 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator((yyvsp[0].var)); }
#line 5478 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1215 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5484 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1216 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5490 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1217 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-3].declarator); append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0); }
#line 5496 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1223 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5502 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1224 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv( (yyloc), (yyval.declarator)->type, (yyvsp[-1].str) ); }
#line 5508 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1231 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5514 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1232 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv( (yyloc), (yyval.declarator)->type, (yyvsp[-1].str) ); }
#line 5520 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1237 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); }
#line 5526 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1243 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5532 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1244 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5538 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1245 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5544 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1247 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5552 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1251 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-3].declarator);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5560 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1259 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5566 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1260 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv( (yyloc), (yyval.declarator)->type, (yyvsp[-1].str) ); }
#line 5572 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1267 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5578 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1268 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv( (yyloc), (yyval.declarator)->type, (yyvsp[-1].str) ); }
#line 5584 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1273 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); }
#line 5590 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1281 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator((yyvsp[0].var)); }
#line 5596 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1282 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5602 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1283 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5608 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1284 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5614 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1286 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5622 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1290 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-3].declarator);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5630 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1296 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[0].declarator) ); }
#line 5636 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1297 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( (yyvsp[-2].declarator_list), (yyvsp[0].declarator) ); }
#line 5642 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1301 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = NULL; }
#line 5648 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1302 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5654 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1305 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); (yyval.declarator)->bits = (yyvsp[0].expr);
						  if (!(yyval.declarator)->bits && !(yyval.declarator)->var->name)
						    error_loc("unnamed fields are not allowed\n");
						}
#line 5663 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1312 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[0].declarator) ); }
#line 5669 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1314 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( (yyvsp[-2].declarator_list), (yyvsp[0].declarator) ); }
#line 5675 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1318 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); }
#line 5681 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1319 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-2].declarator); (yyvsp[-2].declarator)->var->eval = (yyvsp[0].expr); }
#line 5687 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1323 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_APARTMENT; }
#line 5693 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1324 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_NEUTRAL; }
#line 5699 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1325 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_SINGLE; }
#line 5705 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1326 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_FREE; }
#line 5711 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1327 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_BOTH; }
#line 5717 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1328 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_FREE; }
#line 5723 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1332 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_RP; }
#line 5729 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1333 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_UP; }
#line 5735 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1334 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_FP; }
#line 5741 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1337 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_struct((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 5747 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1341 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_void(); }
#line 5753 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1342 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5759 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1343 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5765 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1344 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_enum((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5771 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1345 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5777 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1346 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_struct((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5783 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1347 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5789 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1348 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5795 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1349 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = make_safearray((yyvsp[-1].type)); }
#line 5801 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1350 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(current_namespace, (yyvsp[0].str)); }
#line 5807 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1355 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error((yyvsp[-1].namespace), (yyvsp[0].str)); }
#line 5813 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1356 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5819 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1360 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyvsp[-4].attr_list) = append_attribs((yyvsp[-4].attr_list), (yyvsp[-2].attr_list));
						  reg_typedefs( (yyloc), (yyvsp[-1].declspec), (yyvsp[0].declarator_list), check_typedef_attrs( (yyvsp[-4].attr_list) ) );
						  (yyval.statement) = make_statement_typedef((yyvsp[0].declarator_list), !(yyvsp[-1].declspec)->type->defined);
						}
#line 5828 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1367 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 5834 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1370 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_encapsulated_union((yyvsp[-8].str), (yyvsp[-5].var), (yyvsp[-3].var), (yyvsp[-1].var_list)); }
#line 5840 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1374 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION((yyvsp[0].num), 0); }
#line 5846 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1375 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION((yyvsp[-2].num), (yyvsp[0].num)); }
#line 5852 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1376 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 5858 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1391 "tools/widl/parser.y" /* yacc.c:1646  */
    { type_t *type = find_type_or_error(current_namespace, (yyvsp[-1].str));
                                                  type->attrs = append_attr_list(type->attrs, (yyvsp[-2].attr_list));
                                                }
#line 5866 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1398 "tools/widl/parser.y" /* yacc.c:1646  */
    {  type_t *iface = find_type_or_error(current_namespace, (yyvsp[-3].str));
                                                   if (type_get_type(iface) != TYPE_INTERFACE)
                                                       error_loc("%s is not an interface\n", iface->name);
                                                   iface->attrs = append_attr_list(iface->attrs, (yyvsp[-5].attr_list));
                                                }
#line 5876 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1406 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = NULL; }
#line 5882 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1407 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = (yyvsp[-1].attr_list); }
#line 5888 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1411 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr(NULL, (yyvsp[0].attr)); }
#line 5894 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1412 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr((yyvsp[-2].attr_list), (yyvsp[0].attr)); }
#line 5900 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1417 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_ALLOCATE, (yyvsp[-1].num) ); }
#line 5906 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1418 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_ENCODE, 0 ); }
#line 5912 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1419 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_DECODE, 0 ); }
#line 5918 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1420 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = attr_int( (yyloc), ATTR_EXPLICIT_HANDLE, 0 ); }
#line 5924 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1424 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 5930 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1426 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[-2].num) | (yyvsp[0].num); }
#line 5936 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1430 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_DONT_FREE; }
#line 5942 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1431 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = 0; }
#line 5948 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1432 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_ALLOCATE_ALL_NODES; }
#line 5954 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1433 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = 0; }
#line 5960 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;


#line 5964 "tools/widl/parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1436 "tools/widl/parser.y" /* yacc.c:1906  */


static void decl_builtin_basic(const char *name, enum type_basic_type type)
{
  type_t *t = type_new_basic(type);
  reg_type(t, name, NULL, 0);
}

static void decl_builtin_alias(const char *name, type_t *t)
{
    const decl_spec_t ds = {.type = t};
    reg_type(type_new_alias(&ds, name), name, NULL, 0);
}

void init_types(void)
{
  decl_builtin_basic("byte", TYPE_BASIC_BYTE);
  decl_builtin_basic("wchar_t", TYPE_BASIC_WCHAR);
  decl_builtin_basic("float", TYPE_BASIC_FLOAT);
  decl_builtin_basic("double", TYPE_BASIC_DOUBLE);
  decl_builtin_basic("error_status_t", TYPE_BASIC_ERROR_STATUS_T);
  decl_builtin_basic("handle_t", TYPE_BASIC_HANDLE);
  decl_builtin_alias("boolean", type_new_basic(TYPE_BASIC_CHAR));
}

static str_list_t *append_str(str_list_t *list, char *str)
{
    struct str_list_entry_t *entry;

    if (!str) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->str = str;
    list_add_tail( list, &entry->entry );
    return list;
}


static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right,
        enum storage_class stgclass, enum type_qualifier qual, enum function_specifier func_specifier)
{
  decl_spec_t *declspec = left ? left : right;
  if (!declspec)
  {
    declspec = xmalloc(sizeof(*declspec));
    declspec->type = NULL;
    declspec->stgclass = STG_NONE;
    declspec->qualifier = 0;
    declspec->func_specifier = 0;
  }
  declspec->type = type;
  if (left && declspec != left)
  {
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = left->stgclass;
    else if (left->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    declspec->qualifier |= left->qualifier;
    declspec->func_specifier |= left->func_specifier;
    assert(!left->type);
    free(left);
  }
  if (right && declspec != right)
  {
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = right->stgclass;
    else if (right->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    declspec->qualifier |= right->qualifier;
    declspec->func_specifier |= right->func_specifier;
    assert(!right->type);
    free(right);
  }

  if (declspec->stgclass == STG_NONE)
    declspec->stgclass = stgclass;
  else if (stgclass != STG_NONE)
    error_loc("only one storage class can be specified\n");
  declspec->qualifier |= qual;
  declspec->func_specifier |= func_specifier;

  return declspec;
}

static expr_list_t *append_expr(expr_list_t *list, expr_t *expr)
{
    if (!expr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &expr->entry );
    return list;
}

static void append_array(declarator_t *decl, expr_t *expr)
{
    type_t *array;

    if (!expr)
        return;

    /* An array is always a reference pointer unless explicitly marked otherwise
     * (regardless of what the default pointer attribute is). */
    array = type_new_array(NULL, NULL, FALSE, expr->is_const ? expr->cval : 0,
            expr->is_const ? NULL : expr, NULL);

    append_chain_type(decl, array, 0);
}

static struct list type_pool = LIST_INIT(type_pool);
typedef struct
{
  type_t data;
  struct list link;
} type_pool_node_t;

type_t *alloc_type(void)
{
  type_pool_node_t *node = xmalloc(sizeof *node);
  list_add_tail(&type_pool, &node->link);
  return &node->data;
}

void set_all_tfswrite(int val)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.tfswrite = val;
}

void clear_all_offsets(void)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.typestring_offset = node->data.ptrdesc = 0;
}

static void type_function_add_head_arg(type_t *type, var_t *arg)
{
    if (!type->details.function->args)
    {
        type->details.function->args = xmalloc( sizeof(*type->details.function->args) );
        list_init( type->details.function->args );
    }
    list_add_head( type->details.function->args, &arg->entry );
}

static int is_allowed_range_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_INT3264:
        case TYPE_BASIC_LONG:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_WCHAR:
        case TYPE_BASIC_HYPER:
            return TRUE;
        case TYPE_BASIC_FLOAT:
        case TYPE_BASIC_DOUBLE:
        case TYPE_BASIC_ERROR_STATUS_T:
        case TYPE_BASIC_HANDLE:
            return FALSE;
        }
        return FALSE;
    default:
        return FALSE;
    }
}

static type_t *get_chain_ref(type_t *type)
{
    if (is_ptr(type))
        return type_pointer_get_ref_type(type);
    else if (is_array(type))
        return type_array_get_element_type(type);
    else if (is_func(type))
        return type_function_get_rettype(type);
    return NULL;
}

static type_t *get_chain_end(type_t *type)
{
    type_t *inner;
    while ((inner = get_chain_ref(type)))
        type = inner;
    return type;
}

static void append_chain_type(declarator_t *decl, type_t *type, enum type_qualifier qual)
{
    type_t *chain_type;

    if (!decl->type)
    {
        decl->type = type;
        decl->qualifier = qual;
        return;
    }
    chain_type = get_chain_end(decl->type);

    if (is_ptr(chain_type))
    {
        chain_type->details.pointer.ref.type = type;
        chain_type->details.pointer.ref.qualifier = qual;
    }
    else if (is_array(chain_type))
    {
        chain_type->details.array.elem.type = type;
        chain_type->details.array.elem.qualifier = qual;
    }
    else if (is_func(chain_type))
    {
        chain_type->details.function->retval->declspec.type = type;
        chain_type->details.function->retval->declspec.qualifier = qual;
    }
    else
        assert(0);

    if (!is_func(chain_type))
        type->attrs = move_attr(type->attrs, chain_type->attrs, ATTR_CALLCONV);
}

static void append_chain_callconv( struct location where, type_t *chain, char *callconv )
{
    type_t *chain_end;

    if (chain && (chain_end = get_chain_end(chain)))
        chain_end->attrs = append_attr( chain_end->attrs, attr_ptr( where, ATTR_CALLCONV, callconv ) );
    else
        error_loc("calling convention applied to non-function type\n");
}

static warning_list_t *append_warning(warning_list_t *list, int num)
{
    warning_t *entry;

    if(!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->num = num;
    list_add_tail( list, &entry->entry );
    return list;
}

static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_t *decl,
                       int top)
{
  var_t *v = decl->var;
  expr_list_t *sizes = get_attrp(attrs, ATTR_SIZEIS);
  expr_list_t *lengs = get_attrp(attrs, ATTR_LENGTHIS);
  expr_t *dim;
  type_t **ptype;
  type_t *type = decl_spec->type;

  if (decl_spec->func_specifier & FUNCTION_SPECIFIER_INLINE)
  {
    if (!decl || !is_func(decl->type))
      error_loc("inline attribute applied to non-function type\n");
  }

  /* add type onto the end of the pointers in pident->type */
  append_chain_type(decl, type, decl_spec->qualifier);
  v->declspec = *decl_spec;
  v->declspec.type = decl->type;
  v->declspec.qualifier = decl->qualifier;
  v->attrs = attrs;
  v->declonly = !type->defined;

  if (is_attr(type->attrs, ATTR_CALLCONV) && !is_func(type))
    error_loc("calling convention applied to non-function type\n");

  /* check for pointer attribute being applied to non-pointer, non-array
   * type */
  if (!is_array(v->declspec.type))
  {
    int ptr_attr = get_attrv(v->attrs, ATTR_POINTERTYPE);
    const type_t *ptr = NULL;
    for (ptr = v->declspec.type; ptr && !ptr_attr; )
    {
      ptr_attr = get_attrv(ptr->attrs, ATTR_POINTERTYPE);
      if (!ptr_attr && type_is_alias(ptr))
        ptr = type_alias_get_aliasee_type(ptr);
      else
        break;
    }
    if (is_ptr(ptr))
    {
      if (ptr_attr && ptr_attr != FC_UP &&
          type_get_type(type_pointer_get_ref_type(ptr)) == TYPE_INTERFACE)
          warning_at( &v->where, "%s: pointer attribute applied to interface pointer type has no effect\n", v->name );
      if (!ptr_attr && top)
      {
        /* FIXME: this is a horrible hack to cope with the issue that we
         * store an offset to the typeformat string in the type object, but
         * two typeformat strings may be written depending on whether the
         * pointer is a toplevel parameter or not */
        v->declspec.type = duptype(v->declspec.type, 1);
      }
    }
    else if (ptr_attr)
       error_loc("%s: pointer attribute applied to non-pointer type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_STRING))
  {
    type_t *t = type;

    if (!is_ptr(v->declspec.type) && !is_array(v->declspec.type))
      error_loc("'%s': [string] attribute applied to non-pointer, non-array type\n",
                v->name);

    for (;;)
    {
        if (is_ptr(t))
            t = type_pointer_get_ref_type(t);
        else if (is_array(t))
            t = type_array_get_element_type(t);
        else
            break;
    }

    if (type_get_type(t) != TYPE_BASIC &&
        (get_basic_fc(t) != FC_CHAR &&
         get_basic_fc(t) != FC_BYTE &&
         get_basic_fc(t) != FC_WCHAR))
    {
      error_loc("'%s': [string] attribute is only valid on 'char', 'byte', or 'wchar_t' pointers and arrays\n",
                v->name);
    }
  }

  if (is_attr(v->attrs, ATTR_V1ENUM))
  {
    if (type_get_type_detect_alias(v->declspec.type) != TYPE_ENUM)
      error_loc("'%s': [v1_enum] attribute applied to non-enum type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_RANGE) && !is_allowed_range_type(v->declspec.type))
    error_loc("'%s': [range] attribute applied to non-integer type\n",
              v->name);

  ptype = &v->declspec.type;
  if (sizes) LIST_FOR_EACH_ENTRY(dim, sizes, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        if (!type_array_get_conformance(*ptype) ||
            type_array_get_conformance(*ptype)->type != EXPR_VOID)
          error_loc("%s: cannot specify size_is for an already sized array\n", v->name);
        else
          *ptype = type_new_array((*ptype)->name,
                                  type_array_get_element(*ptype), FALSE,
                                  0, dim, NULL);
      }
      else if (is_ptr(*ptype))
        *ptype = type_new_array((*ptype)->name, type_pointer_get_ref(*ptype), TRUE,
                                0, dim, NULL);
      else
        error_loc("%s: size_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref.type;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem.type;
    else
      error_loc("%s: too many expressions in size_is attribute\n", v->name);
  }

  ptype = &v->declspec.type;
  if (lengs) LIST_FOR_EACH_ENTRY(dim, lengs, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        *ptype = type_new_array((*ptype)->name,
                                type_array_get_element(*ptype),
                                type_array_is_decl_as_ptr(*ptype),
                                type_array_get_dim(*ptype),
                                type_array_get_conformance(*ptype), dim);
      }
      else
        error_loc("%s: length_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref.type;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem.type;
    else
      error_loc("%s: too many expressions in length_is attribute\n", v->name);
  }

  if (decl->bits)
    v->declspec.type = type_new_bitfield(v->declspec.type, decl->bits);

  return v;
}

static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls)
{
  declarator_t *decl, *next;
  var_list_t *var_list = NULL;

  LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
  {
    var_t *var = declare_var(attrs, decl_spec, decl, 0);
    var_list = append_var(var_list, var);
    free(decl);
  }
  free(decl_spec);
  return var_list;
}

typeref_list_t *append_typeref(typeref_list_t *list, typeref_t *ref)
{
    if (!ref) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &ref->entry );
    return list;
}

typeref_t *make_typeref(type_t *type)
{
    typeref_t *ref = xmalloc(sizeof(typeref_t));
    ref->type = type;
    ref->attrs = NULL;
    return ref;
}

var_list_t *append_var(var_list_t *list, var_t *var)
{
    if (!var) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &var->entry );
    return list;
}

static var_list_t *append_var_list(var_list_t *list, var_list_t *vars)
{
    if (!vars) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_move_tail( list, vars );
    return list;
}

var_t *make_var(char *name)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  init_declspec(&v->declspec, NULL);
  v->attrs = NULL;
  v->eval = NULL;
  init_location( &v->where, NULL, NULL );
  v->declonly = FALSE;
  return v;
}

static var_t *copy_var(var_t *src, char *name, map_attrs_filter_t attr_filter)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  v->declspec = src->declspec;
  v->attrs = map_attrs(src->attrs, attr_filter);
  v->eval = src->eval;
  v->where = src->where;
  return v;
}

static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *d)
{
  if (!d) return list;
  if (!list) {
    list = xmalloc(sizeof(*list));
    list_init(list);
  }
  list_add_tail(list, &d->entry);
  return list;
}

static declarator_t *make_declarator(var_t *var)
{
  declarator_t *d = xmalloc(sizeof(*d));
  d->var = var ? var : make_var(NULL);
  d->type = NULL;
  d->qualifier = 0;
  d->bits = NULL;
  return d;
}

static type_t *make_safearray(type_t *type)
{
    decl_spec_t ds = {.type = type};
    ds.type = type_new_alias(&ds, "SAFEARRAY");
    return type_new_array(NULL, &ds, TRUE, 0, NULL, NULL);
}

static typelib_t *make_library(const char *name, const attr_list_t *attrs)
{
    typelib_t *typelib = xmalloc(sizeof(*typelib));
    memset(typelib, 0, sizeof(*typelib));
    typelib->name = xstrdup(name);
    typelib->attrs = attrs;
    list_init( &typelib->importlibs );
    return typelib;
}

static int hash_ident(const char *name)
{
  const char *p = name;
  int sum = 0;
  /* a simple sum hash is probably good enough */
  while (*p) {
    sum += *p;
    p++;
  }
  return sum & (HASHMAX-1);
}

/***** type repository *****/

static struct namespace *find_sub_namespace(struct namespace *namespace, const char *name)
{
  struct namespace *cur;

  LIST_FOR_EACH_ENTRY(cur, &namespace->children, struct namespace, entry) {
    if(!strcmp(cur->name, name))
      return cur;
  }

  return NULL;
}

static void push_namespace(const char *name)
{
  struct namespace *namespace;

  namespace = find_sub_namespace(current_namespace, name);
  if(!namespace) {
    namespace = xmalloc(sizeof(*namespace));
    namespace->name = xstrdup(name);
    namespace->parent = current_namespace;
    list_add_tail(&current_namespace->children, &namespace->entry);
    list_init(&namespace->children);
    memset(namespace->type_hash, 0, sizeof(namespace->type_hash));
  }

  current_namespace = namespace;
}

static void pop_namespace(const char *name)
{
  assert(!strcmp(current_namespace->name, name) && current_namespace->parent);
  current_namespace = current_namespace->parent;
}

static void push_namespaces(str_list_t *names)
{
  const struct str_list_entry_t *name;
  LIST_FOR_EACH_ENTRY(name, names, const struct str_list_entry_t, entry)
    push_namespace(name->str);
}

static void pop_namespaces(str_list_t *names)
{
  const struct str_list_entry_t *name;
  LIST_FOR_EACH_ENTRY_REV(name, names, const struct str_list_entry_t, entry)
    pop_namespace(name->str);
}

static void push_parameters_namespace(const char *name)
{
    struct namespace *namespace;

    if (!(namespace = find_sub_namespace(current_namespace, name)))
    {
        namespace = xmalloc(sizeof(*namespace));
        namespace->name = xstrdup(name);
        namespace->parent = current_namespace;
        list_add_tail(&current_namespace->children, &namespace->entry);
        list_init(&namespace->children);
        memset(namespace->type_hash, 0, sizeof(namespace->type_hash));
    }

    parameters_namespace = namespace;
}

static void pop_parameters_namespace(const char *name)
{
    assert(!strcmp(parameters_namespace->name, name) && parameters_namespace->parent);
    parameters_namespace = NULL;
}

struct rtype {
  const char *name;
  type_t *type;
  int t;
  struct rtype *next;
};

type_t *reg_type(type_t *type, const char *name, struct namespace *namespace, int t)
{
  struct rtype *nt;
  int hash;
  if (!name) {
    error_loc("registering named type without name\n");
    return type;
  }
  if (!namespace)
    namespace = &global_namespace;
  hash = hash_ident(name);
  nt = xmalloc(sizeof(struct rtype));
  nt->name = name;
  if (is_global_namespace(namespace))
  {
    type->c_name = name;
    type->qualified_name = name;
  }
  else
  {
    type->c_name = format_namespace(namespace, "__x_", "_C", name, use_abi_namespace ? "ABI" : NULL);
    type->qualified_name = format_namespace(namespace, "", "::", name, use_abi_namespace ? "ABI" : NULL);
  }
  nt->type = type;
  nt->t = t;
  nt->next = namespace->type_hash[hash];
  namespace->type_hash[hash] = nt;
  return type;
}

static type_t *reg_typedefs( struct location where, decl_spec_t *decl_spec, declarator_list_t *decls, attr_list_t *attrs )
{
  declarator_t *decl;
  type_t *type = decl_spec->type;

  if (is_attr(attrs, ATTR_UUID) && !is_attr(attrs, ATTR_PUBLIC))
    attrs = append_attr( attrs, attr_int( where, ATTR_PUBLIC, 0 ) );

  /* We must generate names for tagless enum, struct or union.
     Typedef-ing a tagless enum, struct or union means we want the typedef
     to be included in a library hence the public attribute.  */
  if (type_get_type_detect_alias(type) == TYPE_ENUM ||
      type_get_type_detect_alias(type) == TYPE_STRUCT ||
      type_get_type_detect_alias(type) == TYPE_UNION ||
      type_get_type_detect_alias(type) == TYPE_ENCAPSULATED_UNION)
  {
    if (!type->name)
    {
      type->name = gen_name();
      if (!is_attr(attrs, ATTR_PUBLIC))
        attrs = append_attr( attrs, attr_int( where, ATTR_PUBLIC, 0 ) );
    }

    /* replace existing attributes when generating a typelib */
    if (do_typelib)
        type->attrs = attrs;
  }

  LIST_FOR_EACH_ENTRY( decl, decls, declarator_t, entry )
  {

    if (decl->var->name) {
      type_t *cur;
      var_t *name;

      cur = find_type(decl->var->name, current_namespace, 0);

      /*
       * MIDL allows shadowing types that are declared in imported files.
       * We don't throw an error in this case and instead add a new type
       * (which is earlier on the list in hash table, so it will be used
       * instead of shadowed type).
       *
       * FIXME: We may consider string separated type tables for each input
       *        for cleaner solution.
       */
      if (cur && input_name == cur->where.input_name)
          error_loc( "%s: redefinition error; original definition was at %s:%d\n",
                     cur->name, cur->where.input_name, cur->where.first_line );

      name = declare_var(attrs, decl_spec, decl, 0);
      cur = type_new_alias(&name->declspec, name->name);
      cur->attrs = attrs;

      reg_type(cur, cur->name, current_namespace, 0);
    }
  }
  return type;
}

type_t *find_type(const char *name, struct namespace *namespace, int t)
{
  struct rtype *cur;

  if(namespace && namespace != &global_namespace) {
    for(cur = namespace->type_hash[hash_ident(name)]; cur; cur = cur->next) {
      if(cur->t == t && !strcmp(cur->name, name))
        return cur->type;
    }
  }
  for(cur = global_namespace.type_hash[hash_ident(name)]; cur; cur = cur->next) {
    if(cur->t == t && !strcmp(cur->name, name))
      return cur->type;
  }
  return NULL;
}

static type_t *find_type_or_error(struct namespace *namespace, const char *name)
{
    type_t *type;
    if (!(type = find_type(name, namespace, 0)) &&
        !(type = find_type(name, parameters_namespace, 0)))
    {
        error_loc("type '%s' not found in %s namespace\n", name, namespace && namespace->name ? namespace->name : "global");
        return NULL;
    }
    return type;
}

static struct namespace *find_namespace_or_error(struct namespace *parent, const char *name)
{
    struct namespace *namespace = NULL;

    if (!winrt_mode)
        error_loc("namespaces are only supported in winrt mode.\n");
    else if (!(namespace = find_sub_namespace(parent, name)))
        error_loc("namespace '%s' not found in '%s'\n", name, parent->name);

    return namespace;
}

int is_type(const char *name)
{
    return find_type(name, current_namespace, 0) != NULL ||
           find_type(name, parameters_namespace, 0);
}

type_t *get_type(enum type_type type, char *name, struct namespace *namespace, int t)
{
  type_t *tp;
  if (!namespace)
    namespace = &global_namespace;
  if (name) {
    tp = find_type(name, namespace, t);
    if (tp) {
      free(name);
      return tp;
    }
  }
  tp = make_type(type);
  tp->name = name;
  tp->namespace = namespace;
  if (!name) return tp;
  return reg_type(tp, name, namespace, t);
}

/***** constant repository *****/

struct rconst {
  char *name;
  var_t *var;
  struct rconst *next;
};

struct rconst *const_hash[HASHMAX];

static var_t *reg_const(var_t *var)
{
  struct rconst *nc;
  int hash;
  if (!var->name) {
    error_loc("registering constant without name\n");
    return var;
  }
  hash = hash_ident(var->name);
  nc = xmalloc(sizeof(struct rconst));
  nc->name = var->name;
  nc->var = var;
  nc->next = const_hash[hash];
  const_hash[hash] = nc;
  return var;
}

var_t *find_const(const char *name, int f)
{
  struct rconst *cur = const_hash[hash_ident(name)];
  while (cur && strcmp(cur->name, name))
    cur = cur->next;
  if (!cur) {
    if (f) error_loc("constant '%s' not found\n", name);
    return NULL;
  }
  return cur->var;
}

char *gen_name(void)
{
  static unsigned long n = 0;
  static const char *file_id;

  if (! file_id)
  {
    char *dst = replace_extension( idl_name, ".idl", "" );
    file_id = dst;

    for (; *dst; ++dst)
      if (! isalnum((unsigned char) *dst))
        *dst = '_';
  }
  return strmake("__WIDL_%s_generated_name_%08lX", file_id, n++);
}

static int is_allowed_conf_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_LONG:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_HYPER:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_WCHAR:
            return TRUE;
        default:
            return FALSE;
        }
    case TYPE_ALIAS:
        /* shouldn't get here because of type_get_type call above */
        assert(0);
        /* fall through */
    case TYPE_STRUCT:
    case TYPE_UNION:
    case TYPE_ENCAPSULATED_UNION:
    case TYPE_ARRAY:
    case TYPE_POINTER:
    case TYPE_VOID:
    case TYPE_MODULE:
    case TYPE_COCLASS:
    case TYPE_FUNCTION:
    case TYPE_INTERFACE:
    case TYPE_BITFIELD:
    case TYPE_RUNTIMECLASS:
    case TYPE_DELEGATE:
        return FALSE;
    case TYPE_APICONTRACT:
    case TYPE_PARAMETERIZED_TYPE:
    case TYPE_PARAMETER:
        /* not supposed to be here */
        assert(0);
        break;
    }
    return FALSE;
}

static int is_ptr_guid_type(const type_t *type)
{
    /* first, make sure it is a pointer to something */
    if (!is_ptr(type)) return FALSE;

    /* second, make sure it is a pointer to something of size sizeof(GUID),
     * i.e. 16 bytes */
    return (type_memsize(type_pointer_get_ref_type(type)) == 16);
}

static void check_conformance_expr_list(const char *attr_name, const var_t *arg, const type_t *container_type, expr_list_t *expr_list)
{
    expr_t *dim;
    struct expr_loc expr_loc;
    expr_loc.v = arg;
    expr_loc.attr = attr_name;
    if (expr_list) LIST_FOR_EACH_ENTRY(dim, expr_list, expr_t, entry)
    {
        if (dim->type != EXPR_VOID)
        {
            const type_t *expr_type = expr_resolve_type(&expr_loc, container_type, dim);
            if (!is_allowed_conf_type(expr_type))
                error_at( &arg->where, "expression must resolve to integral type <= 32bits for attribute %s\n", attr_name );
        }
    }
}

static void check_remoting_fields(const var_t *var, type_t *type);

/* checks that properties common to fields and arguments are consistent */
static void check_field_common(const type_t *container_type,
                               const char *container_name, const var_t *arg)
{
    type_t *type = arg->declspec.type;
    int more_to_do;
    const char *container_type_name;
    const char *var_type;

    switch (type_get_type(container_type))
    {
    case TYPE_STRUCT:
        container_type_name = "struct";
        var_type = "field";
        break;
    case TYPE_UNION:
        container_type_name = "union";
        var_type = "arm";
        break;
    case TYPE_ENCAPSULATED_UNION:
        container_type_name = "encapsulated union";
        var_type = "arm";
        break;
    case TYPE_FUNCTION:
        container_type_name = "function";
        var_type = "parameter";
        break;
    default:
        /* should be no other container types */
        assert(0);
        return;
    }

    if (is_attr(arg->attrs, ATTR_LENGTHIS) &&
        (is_attr(arg->attrs, ATTR_STRING) || is_aliaschain_attr(arg->declspec.type, ATTR_STRING)))
        error_at( &arg->where, "string and length_is specified for argument %s are mutually exclusive attributes\n", arg->name );

    if (is_attr(arg->attrs, ATTR_SIZEIS))
    {
        expr_list_t *size_is_exprs = get_attrp(arg->attrs, ATTR_SIZEIS);
        check_conformance_expr_list("size_is", arg, container_type, size_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_LENGTHIS))
    {
        expr_list_t *length_is_exprs = get_attrp(arg->attrs, ATTR_LENGTHIS);
        check_conformance_expr_list("length_is", arg, container_type, length_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_IIDIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_IIDIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "iid_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_ptr_guid_type(expr_type))
                error_at( &arg->where, "expression must resolve to pointer to GUID type for attribute iid_is\n" );
        }
    }
    if (is_attr(arg->attrs, ATTR_SWITCHIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_SWITCHIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "switch_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_allowed_conf_type(expr_type))
                error_at( &arg->where, "expression must resolve to integral type <= 32bits for attribute %s\n", expr_loc.attr );
        }
    }

    do
    {
        more_to_do = FALSE;

        switch (typegen_detect_type(type, arg->attrs, TDT_IGNORE_STRINGS))
        {
        case TGT_STRUCT:
        case TGT_UNION:
            check_remoting_fields(arg, type);
            break;
        case TGT_INVALID:
        {
            const char *reason = "is invalid";
            switch (type_get_type(type))
            {
            case TYPE_VOID:
                reason = "cannot derive from void *";
                break;
            case TYPE_FUNCTION:
                reason = "cannot be a function pointer";
                break;
            case TYPE_BITFIELD:
                reason = "cannot be a bit-field";
                break;
            case TYPE_COCLASS:
                reason = "cannot be a class";
                break;
            case TYPE_INTERFACE:
                reason = "cannot be a non-pointer to an interface";
                break;
            case TYPE_MODULE:
                reason = "cannot be a module";
                break;
            default:
                break;
            }
            error_at( &arg->where, "%s \'%s\' of %s \'%s\' %s\n", var_type, arg->name, container_type_name, container_name, reason );
            break;
        }
        case TGT_CTXT_HANDLE:
        case TGT_CTXT_HANDLE_POINTER:
            if (type_get_type(container_type) != TYPE_FUNCTION)
                error_at( &arg->where, "%s \'%s\' of %s \'%s\' cannot be a context handle\n",
                          var_type, arg->name, container_type_name, container_name );
            break;
        case TGT_STRING:
        {
            const type_t *t = type;
            while (is_ptr(t))
                t = type_pointer_get_ref_type(t);
            if (is_aliaschain_attr(t, ATTR_RANGE))
                warning_at( &arg->where, "%s: range not verified for a string of ranged types\n", arg->name );
            break;
        }
        case TGT_POINTER:
            if (type_get_type(type_pointer_get_ref_type(type)) != TYPE_VOID ||
                !type->name || strcmp(type->name, "HANDLE"))
            {
                type = type_pointer_get_ref_type(type);
                more_to_do = TRUE;
            }
            break;
        case TGT_ARRAY:
            type = type_array_get_element_type(type);
            more_to_do = TRUE;
            break;
        case TGT_ENUM:
            type = type_get_real_type(type);
            if (!type_is_complete(type))
                error_at( &arg->where, "undefined type declaration \"enum %s\"\n", type->name );
        case TGT_USER_TYPE:
        case TGT_IFACE_POINTER:
        case TGT_BASIC:
        case TGT_RANGE:
            /* nothing to do */
            break;
        }
    } while (more_to_do);
}

static void check_remoting_fields(const var_t *var, type_t *type)
{
    const var_t *field;
    const var_list_t *fields = NULL;

    type = type_get_real_type(type);

    if (type->checked)
        return;

    type->checked = TRUE;

    if (type_get_type(type) == TYPE_STRUCT)
    {
        if (type_is_complete(type))
            fields = type_struct_get_fields(type);
        else
            error_at( &var->where, "undefined type declaration \"struct %s\"\n", type->name );
    }
    else if (type_get_type(type) == TYPE_UNION || type_get_type(type) == TYPE_ENCAPSULATED_UNION)
    {
        if (type_is_complete(type))
            fields = type_union_get_cases(type);
        else
            error_at( &var->where, "undefined type declaration \"union %s\"\n", type->name );
    }

    if (fields) LIST_FOR_EACH_ENTRY( field, fields, const var_t, entry )
        if (field->declspec.type) check_field_common(type, type->name, field);
}

/* checks that arguments for a function make sense for marshalling and unmarshalling */
static void check_remoting_args(const var_t *func)
{
    const char *funcname = func->name;
    const var_t *arg;

    if (!type_function_get_args(func->declspec.type))
        return;

    LIST_FOR_EACH_ENTRY( arg, type_function_get_args(func->declspec.type), const var_t, entry )
    {
        const type_t *type = arg->declspec.type;

        /* check that [out] parameters have enough pointer levels */
        if (is_attr(arg->attrs, ATTR_OUT))
        {
            switch (typegen_detect_type(type, arg->attrs, TDT_ALL_TYPES))
            {
            case TGT_BASIC:
            case TGT_ENUM:
            case TGT_RANGE:
            case TGT_STRUCT:
            case TGT_UNION:
            case TGT_CTXT_HANDLE:
            case TGT_USER_TYPE:
                error_at( &arg->where, "out parameter \'%s\' of function \'%s\' is not a pointer\n", arg->name, funcname );
                break;
            case TGT_IFACE_POINTER:
                error_at( &arg->where, "out interface pointer \'%s\' of function \'%s\' is not a double pointer\n", arg->name, funcname );
                break;
            case TGT_STRING:
                if (is_array(type))
                {
                    /* needs conformance or fixed dimension */
                    if (type_array_has_conformance(type) &&
                        type_array_get_conformance(type)->type != EXPR_VOID) break;
                    if (!type_array_has_conformance(type) && type_array_get_dim(type)) break;
                }
                if (is_attr( arg->attrs, ATTR_IN )) break;
                error_at( &arg->where, "out parameter \'%s\' of function \'%s\' cannot be an unsized string\n", arg->name, funcname );
                break;
            case TGT_INVALID:
                /* already error'd before we get here */
            case TGT_CTXT_HANDLE_POINTER:
            case TGT_POINTER:
            case TGT_ARRAY:
                /* OK */
                break;
            }
        }

        check_field_common(func->declspec.type, funcname, arg);
    }

    if (type_get_type(type_function_get_rettype(func->declspec.type)) != TYPE_VOID)
    {
        var_t var;
        var = *func;
        var.declspec.type = type_function_get_rettype(func->declspec.type);
        var.name = xstrdup("return value");
        check_field_common(func->declspec.type, funcname, &var);
        free(var.name);
    }
}

static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func)
{
    unsigned char explicit_fc, implicit_fc;

    /* check for a defined binding handle */
    if (!get_func_handle_var( iface, func, &explicit_fc, &implicit_fc ) || !explicit_fc)
    {
        /* no explicit handle specified so add
         * "[in] handle_t IDL_handle" as the first parameter to the
         * function */
        var_t *idl_handle = make_var(xstrdup("IDL_handle"));
        idl_handle->attrs = append_attr( NULL, attr_int( iface->where, ATTR_IN, 0 ) );
        idl_handle->declspec.type = find_type_or_error(NULL, "handle_t");
        type_function_add_head_arg(func->declspec.type, idl_handle);
    }
}

static void check_functions(const type_t *iface, int is_inside_library)
{
    const statement_t *stmt;
    /* check for duplicates */
    if (is_attr(iface->attrs, ATTR_DISPINTERFACE))
    {
        var_list_t *methods = type_dispiface_get_methods(iface);
        var_t *func, *func_iter;

        if (methods) LIST_FOR_EACH_ENTRY( func, methods, var_t, entry )
        {
            LIST_FOR_EACH_ENTRY( func_iter, methods, var_t, entry )
            {
                if (func == func_iter) break;
                if (strcmp(func->name, func_iter->name)) continue;
                if (is_attr(func->attrs, ATTR_EVENTADD) != is_attr(func_iter->attrs, ATTR_EVENTADD)) continue;
                if (is_attr(func->attrs, ATTR_EVENTREMOVE) != is_attr(func_iter->attrs, ATTR_EVENTREMOVE)) continue;
                if (is_attr(func->attrs, ATTR_PROPGET) != is_attr(func_iter->attrs, ATTR_PROPGET)) continue;
                if (is_attr(func->attrs, ATTR_PROPPUT) != is_attr(func_iter->attrs, ATTR_PROPPUT)) continue;
                if (is_attr(func->attrs, ATTR_PROPPUTREF) != is_attr(func_iter->attrs, ATTR_PROPPUTREF)) continue;
                error_at( &func->where, "duplicated function \'%s\'\n", func->name );
            }
        }
    }
    if (is_attr(iface->attrs, ATTR_EXPLICIT_HANDLE))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            var_t *func = stmt->u.var;
            add_explicit_handle_if_necessary(iface, func);
        }
    }
    if (!is_inside_library && !is_attr(iface->attrs, ATTR_LOCAL))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            const var_t *func = stmt->u.var;
            if (!is_attr(func->attrs, ATTR_LOCAL))
                check_remoting_args(func);
        }
    }
}

static int async_iface_attrs(attr_list_t *attrs, const attr_t *attr)
{
    switch(attr->type)
    {
    case ATTR_UUID:
        return 0;
    case ATTR_ASYNCUUID:
        append_attr( attrs, attr_ptr( attr->where, ATTR_UUID, attr->u.pval ) );
        return 0;
    default:
        return 1;
    }
}

static int arg_in_attrs(attr_list_t *attrs, const attr_t *attr)
{
    return attr->type != ATTR_OUT && attr->type != ATTR_RETVAL;
}

static int arg_out_attrs(attr_list_t *attrs, const attr_t *attr)
{
    return attr->type != ATTR_IN;
}

static void check_async_uuid(type_t *iface)
{
    statement_list_t *stmts = NULL;
    statement_t *stmt;
    type_t *async_iface;
    type_t *inherit;

    if (!is_attr(iface->attrs, ATTR_ASYNCUUID)) return;

    inherit = type_iface_get_inherit(iface);
    if (inherit && strcmp(inherit->name, "IUnknown"))
        inherit = type_iface_get_async_iface(inherit);
    if (!inherit)
        error_loc("async_uuid applied to an interface with incompatible parent\n");

    async_iface = type_interface_declare(strmake("Async%s", iface->name), iface->namespace);

    STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
    {
        var_t *begin_func, *finish_func, *func = stmt->u.var, *arg;
        var_list_t *begin_args = NULL, *finish_args = NULL, *args;

        if (is_attr(func->attrs, ATTR_CALLAS)) continue;

        args = type_function_get_args(func->declspec.type);
        if (args) LIST_FOR_EACH_ENTRY(arg, args, var_t, entry)
        {
            if (is_attr(arg->attrs, ATTR_IN) || !is_attr(arg->attrs, ATTR_OUT))
                begin_args = append_var(begin_args, copy_var(arg, xstrdup(arg->name), arg_in_attrs));
            if (is_attr(arg->attrs, ATTR_OUT))
                finish_args = append_var(finish_args, copy_var(arg, xstrdup(arg->name), arg_out_attrs));
        }

        begin_func = copy_var(func, strmake("Begin_%s", func->name), NULL);
        begin_func->declspec.type = type_new_function(begin_args);
        begin_func->declspec.type->attrs = func->attrs;
        begin_func->declspec.type->details.function->retval = func->declspec.type->details.function->retval;
        stmts = append_statement(stmts, make_statement_declaration(begin_func));

        finish_func = copy_var(func, strmake("Finish_%s", func->name), NULL);
        finish_func->declspec.type = type_new_function(finish_args);
        finish_func->declspec.type->attrs = func->attrs;
        finish_func->declspec.type->details.function->retval = func->declspec.type->details.function->retval;
        stmts = append_statement(stmts, make_statement_declaration(finish_func));
    }

    type_interface_define(async_iface, map_attrs(iface->attrs, async_iface_attrs), inherit, stmts, NULL);
    iface->details.iface->async_iface = async_iface->details.iface->async_iface = async_iface;
}

static statement_list_t *append_parameterized_type_stmts(statement_list_t *stmts)
{
    statement_t *stmt, *next;

    if (stmts && parameterized_type_stmts) LIST_FOR_EACH_ENTRY_SAFE(stmt, next, parameterized_type_stmts, statement_t, entry)
    {
        switch(stmt->type)
        {
        case STMT_TYPE:
            stmt->u.type = type_parameterized_type_specialize_define(stmt->u.type);
            stmt->declonly = FALSE;
            list_remove(&stmt->entry);
            stmts = append_statement(stmts, stmt);
            break;
        default:
            assert(0); /* should not be there */
            break;
        }
    }

    return stmts;
}

static void check_statements(const statement_list_t *stmts, int is_inside_library)
{
    const statement_t *stmt;

    if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
    {
        switch(stmt->type) {
        case STMT_LIBRARY:
            check_statements(stmt->u.lib->stmts, TRUE);
            break;
        case STMT_TYPE:
            switch(type_get_type(stmt->u.type)) {
            case TYPE_INTERFACE:
                check_functions(stmt->u.type, is_inside_library);
                break;
            case TYPE_COCLASS:
                if(winrt_mode)
                    error_loc("coclass is not allowed in Windows Runtime mode\n");
                break;
            default:
                break;
            }
            break;
        default:
            break;
        }
    }
}

static void check_all_user_types(const statement_list_t *stmts)
{
  const statement_t *stmt;
  const var_t *v;

  if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
  {
    if (stmt->type == STMT_LIBRARY)
      check_all_user_types(stmt->u.lib->stmts);
    else if (stmt->type == STMT_TYPE && type_get_type(stmt->u.type) == TYPE_INTERFACE &&
             !is_local(stmt->u.type->attrs))
    {
      const statement_t *stmt_func;
      STATEMENTS_FOR_EACH_FUNC(stmt_func, type_iface_get_stmts(stmt->u.type)) {
        const var_t *func = stmt_func->u.var;
        if (type_function_get_args(func->declspec.type))
          LIST_FOR_EACH_ENTRY( v, type_function_get_args(func->declspec.type), const var_t, entry )
            check_for_additional_prototype_types(v->declspec.type);
        check_for_additional_prototype_types(type_function_get_rettype(func->declspec.type));
      }
    }
  }
}

static statement_t *make_statement(enum statement_type type)
{
    statement_t *stmt = xmalloc(sizeof(*stmt));
    stmt->type = type;
    return stmt;
}

static statement_t *make_statement_type_decl(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPE);
    stmt->u.type = type;
    stmt->declonly = !type->defined;
    return stmt;
}

static statement_t *make_statement_reference(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPEREF);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_declaration(var_t *var)
{
    statement_t *stmt = make_statement(STMT_DECLARATION);
    stmt->u.var = var;
    if (var->declspec.stgclass == STG_EXTERN && var->eval)
        warning("'%s' initialised and declared extern\n", var->name);
    if (is_const_decl(var))
    {
        if (var->eval)
            reg_const(var);
    }
    else if (type_get_type(var->declspec.type) == TYPE_FUNCTION)
        check_function_attrs(var->name, var->attrs);
    else if (var->declspec.stgclass == STG_NONE || var->declspec.stgclass == STG_REGISTER)
        error_loc("instantiation of data is illegal\n");
    return stmt;
}

static statement_t *make_statement_library(typelib_t *typelib)
{
    statement_t *stmt = make_statement(STMT_LIBRARY);
    stmt->u.lib = typelib;
    return stmt;
}

static statement_t *make_statement_pragma(const char *str)
{
    statement_t *stmt = make_statement(STMT_PRAGMA);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_cppquote(const char *str)
{
    statement_t *stmt = make_statement(STMT_CPPQUOTE);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_importlib(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORTLIB);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_import(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORT);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_module(type_t *type)
{
    statement_t *stmt = make_statement(STMT_MODULE);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_typedef(declarator_list_t *decls, int declonly)
{
    declarator_t *decl, *next;
    statement_t *stmt;

    if (!decls) return NULL;

    stmt = make_statement(STMT_TYPEDEF);
    stmt->u.type_list = NULL;
    stmt->declonly = declonly;

    LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
    {
        var_t *var = decl->var;
        type_t *type = find_type_or_error(current_namespace, var->name);
        stmt->u.type_list = append_typeref(stmt->u.type_list, make_typeref(type));
        free(decl);
        free(var);
    }

    return stmt;
}

static statement_t *make_statement_parameterized_type(type_t *type, typeref_list_t *params)
{
    statement_t *stmt = make_statement(STMT_TYPE);
    stmt->u.type = type_parameterized_type_specialize_partial(type, params);
    return stmt;
}

static statement_t *make_statement_delegate(type_t *ret, var_list_t *args)
{
    declarator_t *decl = make_declarator(make_var(xstrdup("Invoke")));
    decl_spec_t *spec = make_decl_spec(ret, NULL, NULL, STG_NONE, 0, 0);
    append_chain_type(decl, type_new_function(args), 0);
    return make_statement_declaration(declare_var(NULL, spec, decl, FALSE));
}

static statement_list_t *append_statements(statement_list_t *l1, statement_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt)
{
    if (!stmt) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &stmt->entry );
    return list;
}

type_t *find_parameterized_type(type_t *type, typeref_list_t *params)
{
    char *name = format_parameterized_type_name(type, params);

    if (parameters_namespace)
    {
        assert(type->type_type == TYPE_PARAMETERIZED_TYPE);
        type = type_parameterized_type_specialize_partial(type, params);
    }
    else if ((type = find_type(name, type->namespace, 0)))
        assert(type->type_type != TYPE_PARAMETERIZED_TYPE);
    else
        error_loc("parameterized type '%s' not declared\n", name);

    free(name);
    return type;
}
